/*********************************************************************          
 *                                                                   *          
 *         Licensed Materials - Program Property of IBM.             *          
 *         This product contains "Restricted Materials of IBM"       *          
 *         5694-A01 (C) Copyright IBM Corp. 1992, 2001.              *          
 *         All rights reserved.                                      *          
 *         US Government Users Restricted Rights -                   *          
 *         Use, duplication or disclosure restricted                 *          
 *         by GSA ADP Schedule Contract with IBM Corp.               *          
 *         Refer to Copyright Instructions                           *          
 *         Form Number G120-2083.                                    *          
 *                                                                   *          
 *********************************************************************/         
                                                                                
/*------------------------------ cbsamplc.c --------------------------------*   
 |  This is part of cbsample for CS/390 V2R5                                |   
 |  This module provides basic UDP communications functions.  For use in    |   
 |  the cbsample (graphical performance monitor for MVS TCP/IP) it          |   
 |  is linked with cbsamplm.c to make cbsample that                         |   
 |  runs as the server on the MVS host.  It is linked with cbsamplx.c       |   
 |  to make cbsample that runs as the X-Window client on the S/6000 or      |   
 |  SUN.                                                                    |   
 *--------------------------------------------------------------------------*/  
                                                                                
#if defined(MVS)                                                                
#pragma csect (CODE,   "$CBSAMPL")                                              
#pragma csect (STATIC, "#CBSAMPL")                                              
#endif                                                                          
                                                                                
#define cbsamplc_version "1.05a"                                                
                                                                                
/*temporary debugging until get X11 and TCPIP so32dll.dll conflicts resolved*/  
#if !defined(OS2)                                                               
#define USEtcpip                                                                
#endif                                                                          
                                                                                
/* Reminder: SUN doesn't seem to allow #-things to be indented.. might be just  
             this level of compiler. */                                         
                                                                                
#include <ctype.h>                                                              
#include <math.h>                                                               
#include <stdio.h>                                                              
#include <stdlib.h>                                                             
                                                                                
#if defined(MVS)                                                                
#include <bsdtypes.h>                                                           
#include <bsdtime.h>                                                            
#include <in.h>                                                                 
#include <ioctl.h>                                                              
#include <manifest.h>                                                           
#include <socket.h>                                                             
#include <if.h>                                                                 
#include <rtrouteh.h>                                                           
#include <string.h>                                                             
#include <tcperrno.h>                                                           
#include <time.h>                                                               
                                                                                
#else                                                                           
#include <memory.h>                                                             
#include <string.h>                                                             
                                                                                
#if defined(OS2)                                                                
  #include <types.h>                                                            
  #include <utils.h>                                                            
#else                                                                           
#include <sys/types.h>                                                          
#endif                                                                          
                                                                                
#include <netinet/in.h>                                                         
#include <sys/ioctl.h>                                                          
                                                                                
#if defined(sun)                                                                
#else                                                                           
 #if !defined(OS2)                                                              
   #include <sys/devinfo.h>                                                     
 #endif                                                                         
 #include <sys/select.h>                                                        
#endif                                                                          
                                                                                
#include <sys/socket.h>                                                         
                                                                                
#include <time.h>                                                               
#include <sys/time.h>                                                           
#define tcperror perror                                                         
#define ibmsflush(s) 0                                                          
#endif                                                                          
                                                                                
#if defined(MVS)                                                                
#define WHATiAM FROMmvs                                                         
#else                                                                           
#define WHATiAM FROMunixHOST                                                    
#endif                                                                          
                                                                                
#include <errno.h>                                                              
#if defined(OS2)                                                                
  #include <nerrno.h>                                                           
#endif                                                                          
                                                                                
#include <netdb.h>                                                              
                                                                                
#define oops(msg) {tcperror(msg); exit(-1);}                                    
                                                                                
#if !defined(USEtcpip)                                                          
unsigned short bswap(unsigned short i)                                          
{ unsigned short j;                                                             
  printf("my bswap\n");                                                         
  j = i >> 8;                                                                   
  j = j | i << 8;                                                               
  return(j);                                                                    
}                                                                               
#endif                                                                          
                                                                                
#define MAXdgrams              999999999                                        
/*                                                                              
#define MAXwindowSIZE                 31                                        
*/                                                                              
#define MAXwindowSIZE                  7                                        
#define DEFAULTsendQSIZE            8192                                        
#define DEFAULTrecvQSIZE           65768                                        
#define NBUF                           1                                        
#define MAXargvSTRINGlength           25                                        
                                                                                
#define PORTNUM 5001                                                            
#define NUMtriesBEFOREstartingTOwhine  1                                        
#define MAXtriesBEFOREgivingUP        10                                        
                                                                                
/* define loopback as default address for Sender: */                            
#if defined(MVS)                                                                
#define DEFADDR "14.0.0.0"                                                      
#else                                                                           
#define DEFADDR "127.0.0.1"                                                     
#endif                                                                          
                                                                                
int    zero = 0;                                                                
int    one  = 1;                                                                
int    iTRUE = 1;                                                               
int    badbuf = 999999999;                                                      
struct sockaddr_in lsock;                                                       
struct sockaddr_in rsock;                                                       
struct sockaddr_in qsock;                                                       
int s, lsocklen, rsocklen, qsocklen;                                            
#if defined(SUN4)                                                               
#define CLOCKS_PER_SEC 1                                                        
#endif                                                                          
                                                                                
#if defined(MVS)                                                                
#define AccumBlockingReceives          AccumBR                                  
#define AccumBytesReceived             AccumByR                                 
#define AccumBytesSent                 AccumByS                                 
#define AccumDaemonCpu                 AccDaCpu                                 
#define AccumDgramsReceived            AccumDgR                                 
#define AccumDgramsSent                AccumDgS                                 
#define AccumIUCVReceiveMessages       AccumIRM                                 
#define AccumIUCVSendMessages          AccumISM                                 
#define AccumNonBlockingReceives       AccumNBR                                 
#define AccumServerCpu                 AccSvCpu                                 
#define AccumServerIO                  AccSvIO                                  
#define AccumStartTimeStash            AccStTiS                                 
#define AccumTimeouts                  AccTimeo                                 
#define AckToSend                      AckToSen                                 
#define AddVariationToSample           AddVarTo                                 
#define AixUsage_cbsamplx              AixUse_x                                 
#define CalculateTurnaroundTime        CalcTAT                                  
#define ChangeAckLen                   ChangeA                                  
#define ChangeAckLenOnNextDgram        ChangeAN                                 
#define ChangePacing                   ChangeP                                  
#define ChangePacingOnNextDgram        ChangePN                                 
#define ChangeQueueing                 ChangeQ                                  
#define ChangeQueueingOnNextDgram      ChangeQN                                 
#define ClientEndTime                  CliEndT                                  
#define ClientElapsedTime              CliElapT                                 
#define ClientStartTime                CliStT                                   
#define ClientUsefulBytes              CliBytes                                 
#define ClientUsefulMBS                CliMBS                                   
#define CloseMonConnection             CloseMon                                 
#define ConvertToDottedDecimal         ConvToDD                                 
#define CurrAckNum                     CurrAckN                                 
#define CurrDgramNum                   CurrDgNu                                 
#define CurrentWallClockSeconds        CurrWCSe                                 
#define CurrentWallClockUSeconds       CurrWCus                                 
#define DisplayMonUsage                DisMonUs                                 
#define DisplayUsage                   DisUsage                                 
#define DoPollingSelect                DoPolSel                                 
#define DoSelectOnWriteSocket          DoSelWrS                                 
#define DoSomeInits                    DoSomeIn                                 
#define DoXStuff()                                                              
#define EndTimeStash                   EndTimSt                                 
#define fClientElapsedTime             fCliElap                                 
#define FlushOutboundQueue             FlushOut                                 
#define useprofile                     useprofi                                 
#define GetClientStartTime             GetCliSt                                 
#define GetIndUser                     GetIndUs                                 
#define GetServerCurrentTime           GetSrvCu                                 
#define GetServerStartTime             GetSrvSt                                 
#define GetTODNow                      GetTODNo                                 
#define GetWallClockTimeInMicroseconds GetWCTim                                 
#define HandleTheAck                   HandlAck                                 
#define KickSocketIntoBulkmode         KickSock                                 
#define LetsAssumeLoopback             LetsAsum                                 
#define MaxTriesBeforeGivingUp         MaxTryBe                                 
#define MibResponse                    MibResp                                  
#define MibResponseLength              MibRespL                                 
#define monitor_the_monitor            mon_mon                                  
#define MoveTheWindow                  MoveWind                                 
#define MustReturnAllAcks              MustRetu                                 
#define MvsUsage_cbsample              MvsUse_c                                 
#define MyXDispatcher()                                                         
#define NewAckLen                      NewAckLe                                 
#define NewCountsAvailable             NewCouAv                                 
#define NewPacing                      NewPacin                                 
#define NewQueueing                    NewQueue                                 
#define NewRecvQSize                   NewRecvQ                                 
#define NewSendQSize                   NewSendQ                                 
#define NetstatResponse                NetResp                                  
#define NetstatResponseLength          NetRespL                                 
#define nextburst                      nextburs                                 
#define nIUCVrcvd                      nIUCrcvd                                 
#define nIUCVsent                      nIUCsent                                 
#define NormalShutdown                 NormShut                                 
#define nTriesBeforeStartingToWhine    nTriesBe                                 
#define nTriesToConnect                nTriesCo                                 
#define OpenMonConnection              OpenMonC                                 
#define PlotTheGoodStuff()                                                      
#define prevwindow                     prevwind                                 
#define PrintDgram                     PrintDgr                                 
#define QueueingIsAvailable            QingIsAv                                 
#define QueueingIsOn                   QingIsOn                                 
#define QueueingOnReceives             QingOnRe                                 
#define Readgetibmsockopt              Readgeti                                 
#define RecordMessageHasArrived        RecMsgAr                                 
#define RequestNetstatOnNextDgram      ReqNetsN                                 
#define RequestStatisticsOnNextDgram   ReqStatN                                 
#define ResendLastBurst                ResendLB                                 
#define ResetClient                    RstCli                                   
#define ResetServer                    RstSrv                                   
#define ResetServerOnNextDgram         RstSrvNx                                 
#define ResetServerBulkmode            RstSrvBl                                 
#define SavedAccumTAT                  SavAcTAT                                 
#define Savedackbuf                    Savackbu                                 
#define sTATCount                      sTATCnt                                  
#define sTATForThisCycle               sTATForT                                 
#define SeeIfAnyAcksAreThere           SeeIfAck                                 
#define SendAllThatArePossible         SendAllT                                 
#define SendAnyAcksBack                SendAnyA                                 
#define SendDgram                      SendDgra                                 
#define ServerIsOnMVS                  SrvIsOnM                                 
#define ServerUsefulBytes              SrvBytes                                 
#define ServerUsefulMBS                SvrMBS                                   
#define ServerUtil                     SvrUtil                                  
#define SetSocketToNonBlocking         SetSocNo                                 
#define ShowMillisecondsOnMonitor      ShowMili                                 
#define SnapBulkstr                    SnapBulk                                 
#define SnapFlags                      SnapFlgs                                 
#define SnapLastMessage                SnapLast                                 
#define SocketIsLocalNonBlocking       SockIsLN                                 
#define somexdisplay                   somexdis                                 
#define StartTimeStash                 StartTi                                  
#define StartTimeStashs                StartTiS                                 
#define TFLocalNonBlockingAndRecv      TFLocNRe                                 
#define ThisIsLastDgram                ThisIsLa                                 
#define TimedOutThisCycle              TOThisCy                                 
#define TNLocalNonBlockingAndTryRecv   TNLNBlR                                  
#define ToggleQueueing                 ToggleQ                                  
#define ToggleQueueingOnNextDgram      ToggleQN                                 
#define TransmitForXMonitor            TransFXM                                 
#define TryABlockingRecv               TryBlRcv                                 
#define TryANonBlockingRecv            TryNBlRe                                 
#define udploopbench                   udploopb                                 
#define UpdateServerStatus()                                                    
#define UpdateTATDist(tat)                                                      
                                                                                
struct ibm_bulkmode_struct bulkstr;                                             
                                                                                
struct {                                                                        
 char * rx;                                                                     
 char * rx1;                                                                    
 int ry, ry1;                                                                   
 } fourregs;                                                                    
                                                                                
struct timezone {                                                               
    int tz_minuteswest;                                                         
    int tz_dsttime;                                                             
 };                                                                             
                                                                                
typedef enum {                                                                  
     cibstart    = 0x04,                                                        
     cibstc_comm = 0x08,                                                        
     cibmodify   = 0x44,                                                        
     cibstop     = 0x40,                                                        
     cibmount    = 0x0c                                                         
 } CIBVERB;                                                                     
                                                                                
typedef struct cib {                                                            
     struct cib *next;                                                          
     CIBVERB     verb;                                                          
     char        len;                                                           
     char        cscb[4];                                                       
     short       asid;                                                          
     char        conid;                                                         
     char        resvd_1;                                                       
     short       datln;                                                         
     char        data[8];                                                       
 } CIB;                                                                         
                                                                                
typedef struct {                                                                
     unsigned int    wait:1;                                                    
     unsigned int    post:1;                                                    
     unsigned int    rc:30;                                                     
 } ECB;                                                                         
                                                                                
typedef struct {                                                                
     ECB         *ecb;                                                          
     CIB         *cib;                                                          
 } COMLIST;                                                                     
                                                                                
COMLIST *MVScomm(), *comlist;                                                   
                                                                                
#else                                                                           
#define CloseMonConnection()                                                    
#define OpenMonConnection()                                                     
#define ReadMibRecord()                                                         
#define ReadNetstatRecord()                                                     
   void  DoXStuff();                                                            
#if defined(sun)                                                                
void UpdateTATDist();                                                           
#else                                                                           
void UpdateTATDist(int tat);                                                    
#endif                                                                          
#endif                                                                          
                                                                                
#define MAINprogram                                                             
#include "cbsamplh.h"                                                           
                                                                                
  typedef int *size_rcv;                                                        
                                                                                
/*--------------------------------------------------------------------------*   
 * Forward References:                                                      |   
 *--------------------------------------------------------------------------*/  
   void  CalculateTurnaroundTime();                                             
   void  ChangeAckLen();                                                        
   void  ChangePacing();                                                        
   void  ChangeQueueing();                                                      
   void  CloseSoc();                                                            
   void  DisplayMonUsage();                                                     
   void  DisplayUsage();                                                        
   void  DoPollingSelect();                                                     
   void  DoSelectOnWriteSocket();                                               
   void  DoSomeInits();                                                         
   void  FlushOutboundQueue();                                                  
   void  GatherRe();                                                            
   void  GetClientStartTime();                                                  
   void  GetServerCurrentTime();                                                
   void  GetServerStartTime();                                                  
   void  GetTOD();                                                              
   void  GetTODNow();                                                           
 double  GetWallClockTimeInMicroseconds();                                      
   void  KickSocketIntoBulkmode();                                              
   void  MoveTheWindow();                                                       
   void  NormalShutdown();                                                      
   void  OpenRecv();                                                            
   void  OpenSend();                                                            
    int  ParseOut();                                                            
   void  PrintDgram();                                                          
   void  PrtHead();                                                             
   void  PrtTail();                                                             
   void  Receive();                                                             
   void  RecordMessageHasArrived();                                             
   void  ResendLastBurst();                                                     
   void  ResetClient();                                                         
   void  ResetServer();                                                         
   void  ResetServerBulkmode();                                                 
   void  SendAnyAcksBack();                                                     
    int  SendDgram();                                                           
   void  SetSocketToNonBlocking();                                              
   void  SnapBulkstr();                                                         
   void  SnapFlags();                                                           
   void  SnapLastMessage();                                                     
   void  SnapRe();                                                              
    int  TFLocalNonBlockingAndRecv();                                           
   void  ToggleQueueing();                                                      
    int  TNLocalNonBlockingAndTryRecv();                                        
   void  Transmit();                                                            
   void  TransmitForXMonitor();                                                 
    int  TryABlockingRecv();                                                    
    int  TryANonBlockingRecv();                                                 
                                                                                
#define MINselectTIME   5                                                       
#if !defined(min)                                                               
#define min(x,y) ((x) < (y) ? (x) : (y))                                        
#endif                                                                          
#if !defined(max)                                                               
#define max(x,y) ((x) > (y) ? (x) : (y))                                        
#endif                                                                          
                                                                                
                              /***************************************/         
                              /* Set by these options:               */         
                              /*-------------------------------------*/         
int buflen = MAXbufsize;      /* -buf#                               */         
int debug = 0;                /* -d#                                 */         
int debugf = 0;               /* -df                                 */         
int debugp = 0;               /* -dp                                 */         
int debugt = 0;               /* -dt                                 */         
int debugx = 0;               /* -dx                                 */         
int dontfork = 0;             /* -dontfork                           */         
int flushat = 0;              /* -f#                                 */         
char hostname[256] = DEFADDR; /* -h<nodename> -or- -h###.###.###.### */         
int smsglen = MINrequestLENGTH; /* -l#                               */         
int rmsglen = MAXnetstatRESPONSElength; /* -l#                       */         
int monitor_the_monitor = 0;  /* -m or -d0                           */         
int mbtoxfer = 0;             /* -mb#                                */         
int montcpip = 0;             /* -montcpip                           */         
int nlastbuf = 20;            /* -nl#                                */         
int movedata = 1;             /* -nm  =>  movedata=0                 */         
int nobulk   = 0;             /* -nobulk                             */         
int etststor = 1;             /* -nt  =>  etststor=0                 */         
int orignbuf = 0;             /* -n#                                 */         
int pacing = 0;               /* -pa#                                */         
int port = PORTNUM;           /* -po#                                */         
int preview = 0;              /* -pr                                 */         
int bulkmode = 0;             /* bulkmode is not supported.  Do not  */         
                              /* allow bulkmode to be set to one     */         
int sendqlen = 0;             /* -q# && -send                        */         
int recvqlen = 0;             /* -q# && !(-send)                     */         
int reliable = 0;             /* -rel#.#.#.#                         */         
int burstsiz = 4;             /*      first  #                       */         
int window =  MAXdgrams;      /*      second #                       */         
int rseltime = -1;            /*      third  #                       */         
int acklen = MINackLENGTH;    /*      fourth #                       */         
int receiver = 1;             /* -send  =>  receiver=0               */         
int udploopbench= 0;          /* -udploopbench                       */         
int MustReturnAllAcks = 0;    /* -udploopbench                       */         
int useprofile  = 0;          /* -useprofile                         */         
int usetcp      = 0;          /* -usetcp                             */         
int somexdisplay = 0;         /* -x<profile_name>                    */         
char ProfileName[21];         /* <profile_name> taken from -x option.*/         
int usexbench = 0;            /* This is turned on if <profile_name> */         
int usexboth = 0;             /* contains the string, "bench" in it. */         
int usexmon = 0;              /***************************************/         
                                                                                
#define SIZEOFlastDGRAMheader 24*sizeof(int) + sizeof(double)                   
#define LASTdataLEN           MAXbufsize - SIZEOFlastDGRAMheader                
                                                                                
#define dgsLASTdgram       0x80                                                 
#define dgsSENTone         0x40                                                 
#define dgsRECEIVEDackBACK 0x20                                                 
#define dgsRECEIVEDdgram   0x10                                                 
#define dgsREQUESTEDack    0x08                                                 
#define dgsMUSTack         0x04                                                 
#define dgsREQUESTEDstats  0x02                                                 
#define dgsSENDackBACK     0x01                                                 
                                                                                
/***************************************/                                       
/* ++Variables defined in this module: */                                       
/***************************************/                                       
                                                                                
int             AccumBlockingReceives,                                          
                AccumBytesReceived, AccumBytesSent,                             
                AccumDaemonCpu,                                                 
                AccumDgramsReceived, AccumDgramsSent,                           
                AccumIOs,                                                       
                AccumIUCVReceiveMessages, AccumIUCVSendMessages,                
                AccumNonBlockingReceives,                                       
                AccumServerCpu, AccumServerIO;                                  
double          AccumStartTimeStash;                                            
int             AccumTimeouts;                                                  
dgram_format    AckBufs[MAXwindowSIZE];                                         
int             AckToSend = -1;                                                 
struct hostent *addr;                                                           
int             AddVariationToSample;                                           
char            argv_0[20];                                                     
dgram_format    buflast;                                                        
Boolean         ChangeAckLenOnNextDgram = FALSE;                                
Boolean         ChangePacingOnNextDgram = FALSE;                                
Boolean         ChangeQueueingOnNextDgram = FALSE;                              
int             ClientElapsedTime;                                              
double          ClientEndTime,                                                  
                ClientStartTime;                                                
unsigned int    ClientUsefulBytes;                                              
double          ClientUsefulMBS;                                                
int             CurrAckNum,                                                     
                CurrDgramNum;                                                   
double          CurrentWallClockUSeconds;                                       
struct dgstatus_                                                                
 { char flags;                                                                  
   int dgram_num;                                                               
 } dgstatus[MAXwindowSIZE];                                                     
char           *divider =                                                       
"---------------------------------------------------------------------";        
double          EndTimeStash;                                                   
float           f1, f2, f3, f4;                                                 
float           fClientElapsedTime;                                             
fd_set          fdvect;                                                         
int             firstend;                                                       
float           fRecvTT3, fSendTT3, fTcpIO3, fTcpTT3, fTotTT3;                  
int             HighestArrivedSoFar = 0;                                        
int             LetsAssumeLoopback;                                             
int             MaxTriesBeforeGivingUp = MAXtriesBEFOREgivingUP;                
MibResponseType MibResponse;                                                    
int             MibResponseLength;                                              
dgram_format    MsgBuf, MsgBufs[MAXwindowSIZE];                                 
char           *msgp = "cbsample:";                                             
int             nbufrcvd = 0;                                                   
int             nbufrsnt = 0;                                                   
int             nbufsent = 0;                                                   
int             nbytrcvd = 0;                                                   
int             nbytrsnt = 0;                                                   
int             nbytsent = 0;                                                   
int             nduprcvd = 0;                                                   
char            NetstatResponse[MAXnetstatRESPONSElength];                      
int             NetstatResponseLength;                                          
int             NewAckLen = MINackLENGTH;                                       
int             NewCountsAvailable = 0;                                         
int             NewPacing = 0;                                                  
int             NewQueueing = 0;                                                
int             NewRecvQSize = 44;                                              
int             NewSendQSize = 44;                                              
int             nextburst;                                                      
int             nIUCVrcvd = 0;                                                  
int             nIUCVsent = 0;                                                  
int             ntimeout = 0;                                                   
int             nTriesToConnect = 0;                                            
int             nTriesBeforeStartingToWhine = NUMtriesBEFOREstartingTOwhine;    
int             nxtackbf = 0;                                                   
int             argc_passed = 0;                                                
char           *argv_passed[5];                                                 
char            argv_string_passed[5][MAXargvSTRINGlength];                     
dgram_format   *p_dgram;                                                        
double          PreviousWallClockUSeconds;                                      
int             prevwindow;                                                     
Boolean         QueueingIsAvailable = FALSE;                                    
Boolean         QueueingIsOn = FALSE;                                           
Boolean         QueueingOnReceives;                                             
double          RecvTT1, RecvTT2;                                               
char            RecvUser[10];                                                   
double          SendTT1, SendTT2;                                               
/* timers (RecvTT3, TcpTT3, TotTAT, TotTT3) are in microseconds -               
   should be good for 2**32 usec = 71 min,34 sec */                             
unsigned int    RecvTT3;                                                        
int             RequestNetstatOnNextDgram    = FALSE;                           
int             RequestStatisticsOnNextDgram = FALSE;                           
int             ResetServerOnNextDgram       = FALSE;                           
char            resp[512];                                                      
int             SampleInterval;                                                 
struct timeval  SampleTp; /* official timestamp of sample (just after xmit())*/ 
       char     SampTs1[26]; /* and as a string, in seconds                */   
       char     SampTs2[30]; /*     as a string, in milliseconds           */   
       char     SampTs3[30]; /*     as a string, in seconds for monitor TOD*/   
int             SavedAccumTAT;                                                  
dgram_format    Savedackbuf;                                                    
unsigned int    SendTT3;                                                        
char            SendUser[10];                                                   
int             ServerIsOnMVS;                                                  
unsigned int    ServerUsefulBytes;                                              
double          ServerUsefulMBS;                                                
float           ServerUtil;                                                     
Boolean         ShowMillisecondsOnMonitor;                                      
int             Silent = 0;                                                     
int             snext;                                                          
#if defined(MVS)                                                                
int             SocketIsLocalNonBlocking = 0;                                   
#endif                                                                          
int             sorcvbuf = INITsorcvbuf;                                        
int             sosndbuf = INITsosndbuf;                                        
double          StartTimeStash;                                                 
double          StartTimeStashs[MAXwindowSIZE];                                 
int             sTATCount;                                                      
int             sTATForThisCycle;                                               
char            StaticTimeBuf[30];                                              
int             suna;                                                           
#if defined(MVS)                                                                
double          TcpIO1, TcpIO2;                                                 
#endif                                                                          
int             TcpIO3;                                                         
#if defined(MVS)                                                                
double          TcpTT1, TcpTT2;                                                 
#endif                                                                          
unsigned int    TcpTT3;                                                         
#if defined(MVS)                                                                
char            TcpUser[10] = "TCPIP";                                          
#endif                                                                          
int             ThisIsLastDgram = 0;                                            
Boolean         TimedOutThisCycle = FALSE;                                      
struct timeval  timeout;                                                        
int             TimeoutForSelect;                                               
Boolean         ToggleQueueingOnNextDgram = FALSE;                              
unsigned int    TotTAT, TotTT3;                                                 
                                                                                
char AixUsage_cbsamplx[] = {                                                    
"Usage:  cbsample -options                                     default\n\       
        -?       this help.                                          \n\        
        -??      help on monitor codes. (These are terse trace codes \n\        
                                         for debugging this program) \n\        
        -d#      debugging, # = level of debugging                 0 \n\        
                              f: debug fork.                         \n\        
                              p: debug print.                        \n\        
                              t: debug timing.                       \n\        
                              x: debug X.                            \n\        
                              1: simple monitoring.                  \n\        
                              2: simple trace.                       \n\        
                              3: more trace.                         \n\        
                              4-9: ioctl/datagram contents           \n\        
                              >=10: plot information                 \n\        
                                                                     \n\        
        -h<nodename>       hostname address.                         \n\        
           -- or --                                                  \n\        
        -h###.###.###.###  host dotted address.                      \n\        
                                                                     \n\        
        -m       monitoring.                                     off \n\        
        -po#     port number to send to/listen at.              5001 \n\        
                                                                     \n\        
        -x<profile_name> use X Window display to monitor host TCPIP. \n\        
                 <profile_name> is used to select the display format \n\        
                 from the file, .Xdefaults, in your home directory.  \n"};      
                                                                                
char MvsUsage_cbsample[] = {                                                    
"Usage:  cbsample -options                                     default\n\       
        -?       this help.                                          \n\        
        -??      help on monitor codes. (These are terse trace codes \n\        
                                         for debugging this program) \n\        
        -d#      debugging, # = level of debugging                 0 \n\        
                              1: simple monitoring.                  \n\        
                              2: simple trace.                       \n\        
                              3: more trace.                         \n\        
                              >=4: ioctl/datagram contents           \n\        
        -m       monitoring.                                     off \n\        
        -montcpip monitor TCPIP.                                 off \n\        
        -po#     port number to send to/listen at.              5001 \n"};      
                                                                                
char MonUsage[] = {                                                             
"Monitor Codes:                                                       \n\       
        a#:##    send ack for datagram number,<##>, from ack buf,<#>.\n\        
        b#       do a blocking recvfrom(), datagram num. <#> returns.\n\        
        l-       set local NONBLOCKING on.                           \n\        
        l|       set local NONBLOCKING off.                          \n\        
        n        do a non-blocking recvfrom(), no datagram returns.  \n\        
        n#       do a non-blocking recvfrom(), datagram <#> returns. \n\        
        s#       send datagram number, <#>.                          \n\        
        ssa#     re-sendto() folowing select() of ACK number, <#>.   \n\        
        ssd#     re-sendto() folowing select() of Datagram number #. \n\        
        ?r       select() on read socket.   There was >= one ready.  \n\        
        ?r0      select() on read socket.   There were none ready.   \n\        
        ?rt      select() on write socket.  The select() timed out.  \n\        
        ?w       select() on write socket.  There was >= one ready.  \n\        
        ?w0      select() on write socket.  There were none ready.   \n\        
        ?wt      select() on write socket.  The select() timed out.  \n\        
        -        ioctl() to set non-blocking on for the socket.      \n"};      
                                                                                
main(argc,argv)                                                                 
int argc;                                                                       
char **argv;                                                                    
{ char *p;                                                                      
  char *q;                                                                      
  int   qWasPick = 0;                                                           
  char  s1[20];                                                                 
                                                                                
  strcpy(argv_0, argv[0]);                                                      
                                                                                
  msgp = "cbsample";                                                            
                                                                                
  msg2(0, "Starting %s (version %s)", argv_0, cbsamplc_version);                
                                                                                
/*                                                                              
 *  main: first handle parsing of arguments                                     
 */                                                                             
                                                                                
  argv++; argc--;                                                               
  while( argc>0 && argv[0][0] == '-' )                                          
    { int i;                                                                    
      for (i=1; i<strlen(argv[0]); i=i+1)                                       
         argv[0][i] = tolower(argv[0][i]);                                      
      switch (argv[0][1])                                                       
        { case 'b':                                                             
                  if (strcmp(*argv, "-buf") == 0)                               
                    { buflen = atoi(&argv[0][4]); break; }                      
                  DisplayUsage();                                               
          case 'd':                                                             
                  if (argv[0][2] == 'f')                                        
                    { debugf = 1;                                               
                      break;                                                    
                    }                                                           
                  if (argv[0][2] == 'p')                                        
                    { debugp = 1;                                               
                      if (strlen(argv[0]) > 3)                                  
                         debugp = atoi(&argv[0][3]);                            
                      break;                                                    
                    }                                                           
                  if (strncmp(*argv, "-dontfork", 9) == 0)                      
                    { dontfork = 1;                                             
                      break;                                                    
                    }                                                           
                  if (argv[0][2] == 't')                                        
                    { debugt = 1;                                               
                      break;                                                    
                    }                                                           
                  if (argv[0][2] == 'x')                                        
                    { debugx = 1;                                               
                      break;                                                    
                    }                                                           
                  debug = atoi(&argv[0][2]);                                    
                  if (debug == 1)                                               
                    { monitor_the_monitor = 1; debug = 0;                       
                    }                                                           
                  break;                                                        
#if defined(MVS)                                                                
          case 'f':                                                             
                  flushat = atoi(&argv[0][2]);                                  
                  break;                                                        
#endif                                                                          
          case 'h':                                                             
                { int i = 0; int j = 2;                                         
                  if (strlen(argv[0]) == 2)                                     
                    { argv++; argc--; j = 0; } /* <hostname> is in next slot */ 
                  msg(3, "", "Parsing -h option:");                             
                  while ((i<256) && (argv[0][j] != ' ') &&                      
                                   (argv[0][j] != '\0'))                        
                    { msg3(3, "%d:%d=%c",  i, argv[0][j], argv[0][j]);          
                      hostname[i] = argv[0][j];                                 
                      i = i+1; j = j+1;                                         
                    }                                                           
                  hostname[i] = '\0';                                           
                }                                                               
                  break;                                                        
          case 'l':                                                             
                  rmsglen = smsglen = atoi(&argv[0][2]);                        
                  break;                                                        
          case 'm':                                                             
                  if ((argv[0][2] == ' ') ||                                    
                      (argv[0][2] == '\0'))                                     
                    { monitor_the_monitor = 1; break; }                         
#if defined(MVS)                                                                
                  if (strncmp(*argv, "-montcpip", 9) == 0)                      
                    { montcpip = 1; break; }                                    
#endif                                                                          
                  if (strncmp(*argv, "-mb", 3) == 0)                            
                    { mbtoxfer = atoi(&argv[0][3]); break; }                    
                  DisplayUsage();                                               
          case 'n':                                                             
                  if (strncmp(*argv, "-nl", 3) == 0)                            
                    { nlastbuf = atoi(&argv[0][3]); break; }                    
#if defined(MVS)                                                                
                  if (strncmp(*argv, "-nm", 3) == 0)                            
                    { movedata = 0; break; }                                    
                  if (strncmp(*argv, "-nt", 3) == 0)                            
                    { etststor = 0; break; }                                    
#endif                                                                          
#if !defined(MVS)                                                               
                  if (strncmp(*argv, "-nobulk", 7) == 0)                        
                    { nobulk = 1; break; }                                      
#endif                                                                          
                  orignbuf = atoi(&argv[0][2]);                                 
                  break;                                                        
          case 'p':                                                             
                  if (strncmp(*argv, "-pa", 3) == 0)                            
                    { pacing = atoi(&argv[0][3]); break; }                      
                  if (strncmp(*argv, "-po", 3) == 0)                            
                    { port = atoi(&argv[0][3]); break; }                        
                  if (strncmp(*argv, "-pr", 3) == 0)                            
                    { preview = 1; break; }                                     
                  DisplayUsage();                                               
          case 'r':                                                             
                  if (strncmp(*argv, "-rel", 4) == 0)                           
                    { reliable = 1; window = 15;                                
                      if (*(p = &argv[0][4]) == 0) goto nomore;                 
                      strcpy(s1,". ");                                          
                      if (p == (q = (char *)strpbrk(p,s1))) goto nomore;        
                      burstsiz = atoi(p); p = q + 1;                            
                      if (!q || (p == (q = (char *)strpbrk(p,s1))))             
                         goto nomore;                                           
                      window = atoi(p); p = q + 1;                              
                      if (!q || (p == (q = (char *)strpbrk(p,". \0"))))         
                         goto nomore;                                           
                      rseltime = atoi(p); p = q + 1;                            
                      if (!q || (p == (q = (char *)strpbrk(p,". \0"))))         
                         goto nomore;                                           
                      acklen = atoi(p);                                         
                     nomore:                                                    
                      nlastbuf = 1;                                             
                      break;                                                    
                    }                                                           
                  DisplayUsage();                                               
          case 's':                                                             
                  if (strcmp(*argv, "-send") == 0)                              
                    { receiver = 0; break; }                                    
                  DisplayUsage();                                               
          case 'u':                                                             
                  if (strncmp(*argv, "-udploopbench", 13) == 0)                 
                    { udploopbench = 1;                                         
                      MustReturnAllAcks = 1;                                    
                      burstsiz = 0;                                             
                      nlastbuf = 1;                                             
                      break;                                                    
                    }                                                           
                  if (strncmp(*argv, "-useprofile", 11) == 0)                   
                    { useprofile = 1;                                           
                      break;                                                    
                    }                                                           
                  if (strncmp(*argv, "-usetcp", 7) == 0)                        
                    { usetcp = 1;                                               
                      break;                                                    
                    }                                                           
                  DisplayUsage();                                               
#if !defined(MVS)                                                               
          case 'x':                                                             
                { int i = 0; int j = 2;                                         
                  if (strlen(argv[0]) == 2)                                     
                    { argv++; argc--; j = 0; } /* <profile_name> is in next */  
                  msg(3, "", "Parsing -x option:");                 /* slot */  
                  while ((i<20) && (argv[0][j] != ' ') &&                       
                                   (argv[0][j] != '\0'))                        
                    { msg3(3, "%d:%d=%c",  i, argv[0][j], argv[0][j]);          
                      ProfileName[i] = argv[0][j];                              
                      i = i+1; j = j+1;                                         
                    }                                                           
                  ProfileName[i] = '\0';                                        
                }                                                               
                  montcpip = somexdisplay = Silent = 1;                         
                  receiver = 0;                                                 
                  break;                                                        
#endif                                                                          
          case '?':                                                             
                  if (strncmp(*argv, "-??", 3) == 0)                            
                    { DisplayMonUsage();                                        
                      break;                                                    
                    }                                                           
                  DisplayUsage();                                               
                  break;                                                        
          default:                                                              
            DisplayUsage();                                                     
        }                                                                       
      argv++; argc--;                                                           
    }                                                                           
                                                                                
  if ((!orignbuf && receiver) || somexdisplay)                                  
    { orignbuf = MAXdgrams; mbtoxfer = 0;                                       
    }                                                                           
    else                                                                        
    if ((!orignbuf) && mbtoxfer)                                                
       orignbuf = mbtoxfer * 1000000 / smsglen;                                 
       else if ((!orignbuf) && (!mbtoxfer))                                     
              { if (receiver)                                                   
                   orignbuf = MAXdgrams;                                        
                   else orignbuf = 1;                                           
              }                                                                 
              else mbtoxfer = 0;                                                
                                                                                
  if (somexdisplay)                                                             
    { usexbench = (strstr(ProfileName,"bench") != NULL);                        
      usexmon = 1;                                                              
      usexboth = usexbench && usexmon;                                          
    }                                                                           
                                                                                
  if (qWasPick)                                                                 
    { sendqlen = 8 + qWasPick * (28 + smsglen);                                 
      recvqlen = qWasPick * (24 + rmsglen);                                     
    }                                                                           
                                                                                
  if (debug >= 2)                                                               
    { printf("%s parms: bulkmode=%d, debug=%d, eteststor=%d\n",                 
                           msgp, bulkmode, debug, etststor);                    
      printf("%s        mbtoxfer=%d, monitor_the_monitor=%d, montcpip=%d,\n",   
                           msgp, mbtoxfer,  monitor_the_monitor, montcpip);     
      printf("%s        nlastbuf=%d, orignbuf=%d, pacing=%d,port=%d, \n",       
                           msgp, nlastbuf, orignbuf, pacing, port);             
      printf("%s        receiver=%d, rmsglen=%d, sendqlen=%d, smsglen=%d,\n",   
                           msgp, receiver, rmsglen, sendqlen, smsglen);         
      printf("%s        somexdisplay=%d,usexbench=%d,usexboth=%d,usexmon=%d.\n",
                           msgp, somexdisplay, usexbench, usexboth, usexmon);   
      if (!receiver)                                                            
         printf("%s        We are a sender, host=%s, movedata=%d.\n",           
                           msgp, hostname, movedata);                           
      if (usexmon)                                                              
         printf(                                                                
          "%s        We are starting the graphical monitor for profile, %s.\n", 
                          msgp, ProfileName);                                   
    }                                                                           
    if (receiver)                                                               
      { msg(0, "", "Receiving datagrams.");                                     
        if (reliable)                                                           
           msg(0, "", "Using a protocol for reliable delivery.");               
        msg1(0, "Using %d-byte message buffer for recvfrom().", buflen);        
      }                                                                         
      else                                                                      
      { if (reliable)                                                           
          { msg3(0, "Sending %d %d-byte dgrams.",                               
                 orignbuf, smsglen, nlastbuf);                                  
            msg(0, "", "Using a protocol for reliable delivery.");              
          }                                                                     
          else                                                                  
          if (!somexdisplay)                                                    
             msg3(0, "Sending %d %d-byte dgrams plus %d ending datagrams.",     
                  orignbuf, smsglen, nlastbuf);                                 
      }                                                                         
    if (bulkmode && receiver)                                                   
      { msg1(0, "Using bulkmode recv queue of %d bytes.", recvqlen);            
        if (!etststor) msg(0, "", "Not using teststor.");                       
      }                                                                         
                                                                                
  DoSomeInits();                                                                
                                                                                
  if (receiver)                                                                 
    { if (montcpip)                                                             
         OpenMonConnection();                                                   
      OpenRecv();                                                               
    }                                                                           
  else OpenSend();                                                              
                                                                                
  if ((!receiver) && somexdisplay)                                              
     DoXStuff();                                                                
                                                                                
  if (receiver)                                                                 
     Receive();                                                                 
  else Transmit();                                                              
                                                                                
  NormalShutdown();                                                             
                                                                                
  return(0);                                                                    
}                                                                               
                                                                                
void DisplayMonUsage()                                                          
{ printf(MonUsage);                                                             
  exit(0);                                                                      
}                                                                               
                                                                                
void DisplayUsage()                                                             
{ if (WHATiAM == FROMunixHOST)                                                  
    { printf(AixUsage_cbsamplx); exit(0); }                                     
                                                                                
  if (WHATiAM == FROMmvs)                                                       
    { printf(MvsUsage_cbsample); exit(0); }                                     
                                                                                
  printf("We don\'t know if we are *IX or MVS ... should not be here!\n");      
  exit(-1);                                                                     
}                                                                               
                                                                                
/*--------------------------------------------------------------------*         
 | --Sender                                                           |         
 |                     window                                         |         
 |            <-----------+----------->                               |         
 |           +-------------------------+                              |         
 |  ---------|-------------------------|-------------------------     |         
 | |         | sent, but not | not yet |                         |    |         
 | |         | acknowledged  |   sent  |                         |    |         
 |  ---------|-------------------------|-------------------------     |         
 |           +-------------------------+                              |         
 |            A               A                                       |         
 |            |               |                                       |         
 |          suna            snext                                     |         
 *--------------------------------------------------------------------*/        
                                                                                
/*=============================*                                                
 | --CalculateTurnaroundTime() |                                                
 *=============================*/                                               
                                                                                
void CalculateTurnaroundTime()                                                  
{ double AckEndTime;                                                            
  int tat;                                                                      
  /* AckEndTime marks the end of the request to the server. */                  
  /* Calculate the TurnaroundTime displayed by the monitor. */                  
  AckEndTime = GetWallClockTimeInMicroseconds();                                
/*tat = (int)((AckEndTime - MsgBuf.start_time)/100.0); */                       
  tat = (int)((AckEndTime - AccumStartTimeStash)/100.0);                        
  TotTAT = TotTAT + tat;                                                        
  AccumStartTimeStash = -1.0;                                                   
  SavedAccumTAT = SavedAccumTAT + tat;                                          
  sTATCount = sTATCount + 1;                                                    
  sTATForThisCycle = (int) ((EndTimeStash - StartTimeStash)/100.0);             
  UpdateTATDist(tat);                                                           
} /* CalculateTurnaroundTime() */                                               
                                                                                
/*==================*                                                           
 | --ChangeAckLen() |                                                           
 *==================*/                                                          
                                                                                
void ChangeAckLen()                                                             
{ ChangeAckLenOnNextDgram = TRUE;                                               
} /* ChangeAckLen() */                                                          
                                                                                
/*==================*                                                           
 | --ChangePacing() |                                                           
 *==================*/                                                          
                                                                                
void ChangePacing()                                                             
{ ChangePacingOnNextDgram = TRUE;                                               
} /* ChangePacing() */                                                          
                                                                                
/*=====================*                                                        
 | --ChangeQueueuing() |                                                        
 *=====================*/                                                       
                                                                                
void ChangeQueueing()                                                           
{ if (bulkmode)                                                                 
     ChangeQueueingOnNextDgram = TRUE;                                          
} /* ChangeQueueing() */                                                        
                                                                                
/*==============*                                                               
 | --CloseSoc() |                                                               
 *==============*/                                                              
                                                                                
void CloseSoc()                                                                 
{ msg1(-3, "About to call close(%d).", s);                                      
  close(s); /* Just a note:                                                     
               Don't close() the socket before doing the getibmsockopt()        
               to get the counts; otherwise the counts are lost.                
            */                                                                  
  msg(3, "", "Back from close().");                                             
}  /* CloseSoc() */                                                             
                                                                                
/*==============*                                                               
 | --cmpbytes() |                                                               
 *==============*/                                                              
                                                                                
int cmpbytes(expected, actual, offset, len)                                     
char *expected;                                                                 
char *actual;                                                                   
int   offset;                                                                   
int   len;                                                                      
{ int i;                                                                        
  for (i=offset; i<offset+len; i=i+1)                                           
      if (expected[i] != actual[i])                                             
        { printf("%s cmpbytes: i=%d expected[i]=%2X actual[i]=%2X\n",           
                 msgp, i, expected[i], actual[i]);                              
          return(i+1);                                                          
        }                                                                       
  return(0);                                                                    
} /* cmpbytes() */                                                              
                                                                                
/*============================*                                                 
 | --ConvertToDottedDecimal() |                                                 
 *============================*/                                                
                                                                                
void ConvertToDottedDecimal(theaddr, result)                                    
int  theaddr;                                                                   
char result[];                                                                  
{ char s1[5];                                                                   
  sprintf(s1,"%d.", theaddr              >>24); strcpy(result, s1);             
  sprintf(s1,"%d.",(theaddr & 0x00FF0000)>>16); strcat(result, s1);             
  sprintf(s1,"%d.",(theaddr & 0x0000FF00)>> 8); strcat(result, s1);             
  sprintf(s1,"%d", (theaddr & 0x000000FF)    ); strcat(result, s1);             
} /* ConvertToDottedDecimal() */                                                
                                                                                
/*=====================*                                                        
 | --DoPollingSelect() |                                                        
 *=====================*/                                                       
                                                                                
void DoPollingSelect(timeoutsecs, TimedOut)                                     
int timeoutsecs; int *TimedOut;                                                 
{ int retcode; char buf[80];                                                    
                                                                                
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *            
   | Issue select() to return when either socket is ready to be    |            
   | read or the timeout occurs.                                   |            
   * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */           
                                                                                
  *TimedOut = 0;                                                                
 TryAgain:                                                                      
  FD_ZERO((struct fd_set *)&fdvect);                                            
  FD_SET(s, (struct fd_set *)&fdvect);                                          
  timeout.tv_sec = timeoutsecs;                                                 
  timeout.tv_usec = 0;                                                          
#if defined(OS2)                                                                
  { int splus1, i1;                                                             
    long l1;                                                                    
    splus1 = s + 1;                                                             
    memcpy(&i1, &fdvect, sizeof(int));                                          
                                                                                
    l1 = 1; /* ??? */                                                           
                                                                                
#if defined(USEtcpip)                                                           
  if (debug == 2)                                                               
    { msg(2, "", "About to select() on read socket.");                          
    }                                                                           
  else                                                                          
   { sprintf(buf, "About to select() on read socket.");                         
     msg(-3, "?r", buf);                                                        
   }                                                                            
    retcode = select(&splus1, i1, 0, 0, l1);                                    
#else                                                                           
    retcode = 0;                                                                
#endif                                                                          
  }                                                                             
#else  /* not OS2 */                                                            
                                                                                
#if defined(USEtcpip)                                                           
  if (debug == 2)                                                               
    { msg(2, "", "About to select() on read socket.");                          
    }                                                                           
  else                                                                          
   { sprintf(buf, "About to select() on read socket.");                         
     msg(-3, "?r", buf);                                                        
   }                                                                            
  retcode = select(s+1, (struct fd_set *) &fdvect,                              
                        (struct fd_set *)0, (struct fd_set *)0,                 
                        (struct timeval *) &timeout);                           
#else                                                                           
  retcode = 0;                                                                  
#endif /* USEtcpip */                                                           
#endif                                                                          
  EndTimeStash = GetWallClockTimeInMicroseconds();                              
                                                                                
  msg3(2, "Back from select(), rc=%d, timeout used was %d.%d.",                 
           retcode, timeout.tv_sec,timeout.tv_usec);                            
                                                                                
  if (retcode == 0)                                                             
    { *TimedOut = 1;                                                            
      if (!monitor_the_monitor && !Silent)                                      
        { printf(                                                               
             "%s Timeout: nbufsent=%d, suna=%d, burst=%d, window=%d.\n",        
              msgp, nbufsent, suna, burstsiz, window);                          
        }                                                                       
      ntimeout = ntimeout + 1;                                                  
    }                                                                           
                                                                                
  if (retcode < 0)                                                              
#if defined(OS2)                                                                
    { oops("on select() in DoPollingSelect()"); }                               
#else                                                                           
     if (errno == EINTR)                                                        
       { if (debugt)                                                            
            printf(                                                             
      "EINTR on select() in DoPollingSelect(),going to try select() again.\n"); 
         goto TryAgain;                                                         
       }                                                                        
       else                                                                     
       { oops("on select() in DoPollingSelect()"); }                            
#endif                                                                          
                                                                                
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *            
   | 'retcode > 0' means socket is ready to be read.               |            
   | Just check to see that the right bit is set in the flags.     |            
   * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */           
                                                                                
  if (monitor_the_monitor)                                                      
     if (retcode == 0)                                                          
        if (timeoutsecs == 0)                                                   
           printf("0.");                                                        
        else printf("t.");                                                      
     else printf(".");                                                          
  if (retcode > 0)                                                              
    { if (!FD_ISSET(s, &fdvect))                                                
         oops("select returns w/ wrong socket bit set.. hmm.");                 
    }                                                                           
}  /* DoPollingSelect() */                                                      
                                                                                
/*===========================*                                                  
 | --DoSelectOnWriteSocket() |                                                  
 *===========================*/                                                 
                                                                                
void DoSelectOnWriteSocket(timeoutsecs, TimedOut)                               
int timeoutsecs; int *TimedOut;                                                 
{ int retcode;                                                                  
                                                                                
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *            
   | Issue select() to return when either socket is ready to be    |            
   | read or the timeout occurs.                                   |            
   * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */           
                                                                                
  *TimedOut = 0;                                                                
                                                                                
  FD_ZERO((struct fd_set *)&fdvect);                                            
  FD_SET(s, (struct fd_set *)&fdvect);                                          
  timeout.tv_sec = timeoutsecs;                                                 
  timeout.tv_usec = 0;                                                          
#if defined(OS2)                                                                
  { int  splus1, i1;                                                            
    long l1;                                                                    
    splus1 = s + 1;                                                             
    memcpy(&i1, &fdvect, sizeof(int));                                          
                                                                                
    l1 = 1; /* ??? */                                                           
                                                                                
#if defined(USEtcpip)                                                           
  msg(-3, ".?w", "About to select() on write socket.");                         
    retcode = select(&splus1, 0, i1, 0, l1);                                    
#else                                                                           
    retcode = 0;                                                                
#endif                                                                          
  }                                                                             
#else                                                                           
#if defined(USEtcpip)                                                           
  msg(-3, ".?w", "About to select() on write socket.");                         
  retcode = select(s+1, (struct fd_set *)0,                                     
                        (struct fd_set *) &fdvect, (struct fd_set *)0,          
                        (struct timeval *) &timeout);                           
#else                                                                           
  retcode = 0;                                                                  
#endif                                                                          
#endif                                                                          
  msg3(3, "Back from select() on write socket, rc=%d, timeout used was %d.%d.", 
           retcode, timeout.tv_sec,timeout.tv_usec);                            
  if (retcode == 0)                                                             
    { *TimedOut = 1;                                                            
      if (!monitor_the_monitor && !Silent)                                      
        { printf(                                                               
             "%s Timeout: nbufsent=%d, suna=%d, burst=%d, window=%d.\n",        
              msgp, nbufsent, suna, burstsiz, window);                          
        }                                                                       
      ntimeout = ntimeout + 1;                                                  
    }                                                                           
  if (retcode < 0)                                                              
    { oops("on select() on write socket"); }                                    
                                                                                
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *            
   | 'retcode > 0' means socket is ready to be writen.             |            
   | Just check to see that the right bit is set in the flags.     |            
   * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */           
                                                                                
  if (monitor_the_monitor)                                                      
     if (retcode == 0)                                                          
        if (timeoutsecs == 0)                                                   
           printf("0.");                                                        
        else printf("t.");                                                      
     else printf(".");                                                          
  if (retcode > 0)                                                              
    { if (!FD_ISSET(s, &fdvect))                                                
      oops("select (on wr soc) returns w/ wrong socket bit set.. hmm.");        
    }                                                                           
}  /* DoSelectOnWriteSocket() */                                                
                                                                                
/*=================*                                                            
 | --DoSomeInits() |                                                            
 *=================*/                                                           
                                                                                
void DoSomeInits()                                                              
{ AccumStartTimeStash = -1;                                                     
#if defined(MVS)                                                                
  comlist = MVScomm(0);                                                         
#endif                                                                          
} /* DoSomeInits() */                                                           
                                                                                
/*=============*                                                                
 | --DumpStg() |                                                                
 *=============*/                                                               
                                                                                
void DumpStg(loc, count)                                                        
int *loc;                                                                       
int count;                                                                      
{ int i,j;                                                                      
  j = (count + 3) / 4;                                                          
  for (i=0; i<j; i=i+1)                                                         
      if (((i+1) % 8) == 0)                                                     
         printf("%08X\n",*(loc + i));                                           
      else printf("%08X ",*(loc + i));                                          
} /* DumpStg() */                                                               
                                                                                
/*========================*                                                     
 | --FlushOutboundQueue() |                                                     
 *========================*/                                                    
                                                                                
void FlushOutboundQueue()                                                       
{                                                                               
#if defined(MVS)                                                                
  msg(-3, "f", "About to ibmsflush().");                                        
  if (ibmsflush(s) < 0) oops("on ibmsflush()");                                 
  msg(3, ".", "Back from ibmsflush().");                                        
#endif                                                                          
} /* FlushOutboundQueue() */                                                    
                                                                                
/*========================*                                                     
 | --GetClientStartTime() |                                                     
 *========================*/                                                    
                                                                                
void GetClientStartTime()                                                       
{ ClientStartTime = GetWallClockTimeInMicroseconds();                           
  f1 = (double)clock();                                                         
  SendTT1 = f1 * 1000000 / CLOCKS_PER_SEC;                                      
}  /* GetClientStartTime() */                                                   
                                                                                
/*===========================*                                                  
 | --GetHiResWallClockTime() |                                                  
 *===========================*/                                                 
                                                                                
#if defined(MVS)                                                                
#else                                                                           
#if defined(sun) || defined(OS2)                                                
double GetHiResWallClockTime()  /* returns microseconds. */                     
{ double total;                                                                 
  total = GetWallClockTimeInMicroseconds();                                     
  return(total);                                                                
} /* GetHiResWallClockTime() */                                                 
#else                                                                           
double GetHiResWallClockTime()  /* returns microseconds. */                     
{ struct timestruc_t Tsp;                                                       
  double total, secpart;                                                        
  gettimer(TIMEOFDAY, &Tsp);                                                    
  secpart = ((double)((unsigned long)Tsp.tv_sec) * 1000000);                    
  total = secpart + (unsigned long)(Tsp.tv_nsec/1000);                          
  return(total);                                                                
} /* GetHiResWallClockTime() */                                                 
#endif                                                                          
#endif                                                                          
                                                                                
/*================*                                                             
 | --GetIndUser() |                                                             
 *================*/                                                            
                                                                                
/*==========================*                                                   
 | --GetServerCurrentTime() |                                                   
 *==========================*/                                                  
                                                                                
void GetServerCurrentTime()                                                     
{                                                                               
  f1 = (double)clock();                                                         
  RecvTT2 = (f1 * 1000000.0 / CLOCKS_PER_SEC);                                  
}  /* GetServerCurrentTime() */                                                 
                                                                                
/*========================*                                                     
 | --GetServerStartTime() |                                                     
 *========================*/                                                    
                                                                                
void GetServerStartTime()                                                       
{                                                                               
  f1 = (double)clock();                                                         
  RecvTT1 = (f1 * 1000000.0 / CLOCKS_PER_SEC);                                  
}  /* GetServerStartTime() */                                                   
                                                                                
/*============*                                                                 
 | --GetTOD() |                                                                 
 *============*/                                                                
                                                                                
void GetTOD(Tp, resolution, result)                                             
struct timeval   Tp;                                                            
resolution_types resolution;                                                    
char             result[];                                                      
{ char buf1[26];                                                                
  char buf2[4];                                                                 
  int  i;                                                                       
                                                                                
  msg3(-10, "GetTOD(): Tp=%d.%d, resolution=%d",                                
             Tp.tv_sec,Tp.tv_usec, resolution);                                 
                                                                                
  if (resolution == SECONDS)                                                    
#if defined(MVS)                                                                
    { strcpy(result, "xxxxxxxxxxxxxxxxxxxxxxxx");                               
#else                                                                           
    { strcpy(result, ctime((long *)&Tp.tv_sec));                                
#endif                                                                          
      result[24] = '\0';                                                        
    }                                                                           
    else                                                                        
#if defined(MVS)                                                                
    { strcpy(buf1, "xxxxxxxxxxxxxxxxxxxxxxxx");                                 
#else                                                                           
    { strcpy(buf1,ctime((long *)&Tp.tv_sec));                                   
#endif                                                                          
      sprintf(buf2, "%03d", Tp.tv_usec/1000);                                   
      for (i=0; i<19; i=i+1)                                                    
         result[i] = buf1[i];                                                   
      result[19] = '.';                                                         
      for (i=0; i<3; i=i+1)                                                     
         result[20+i] = buf2[i];                                                
      result[23] = ' ';                                                         
      for (i=0; i<4; i=i+1)                                                     
         result[24+i] = buf1[20+i];                                             
      result[28] = '\0';                                                        
    }                                                                           
                                                                                
  msg1(-10, "GetTOD(): result=%s", result);                                     
                                                                                
} /* GetTOD() */                                                                
                                                                                
/*===============*                                                              
 | --GetTODNow() |                                                              
 *===============*/                                                             
                                                                                
void GetTODNow(resolution, result)                                              
resolution_types resolution;                                                    
char             result[];                                                      
{ struct timeval Tp;                                                            
  struct timezone Tpz;                                                          
                                                                                
  msg1(-10, "GetTODNow(): resolution=%d", resolution);                          
                                                                                
  gettimeofday(&Tp, &Tpz);                                                      
  GetTOD(Tp, resolution, result);                                               
                                                                                
} /* GetTODNow() */                                                             
                                                                                
/*====================================*                                         
 | --GetWallClockTimeInMicroseconds() |                                         
 *====================================*/                                        
                                                                                
double GetWallClockTimeInMicroseconds()    /* returns microseconds */           
{ struct timeval Tp;                                                            
  struct timezone Tpz;                                                          
  double total;                                                                 
  gettimeofday(&Tp, &Tpz);                                                      
  total = (((double)Tp.tv_sec) * 1000000) + ((double)Tp.tv_usec);               
  return(total);                                                                
} /* GetWallClockTimeInMicroseconds() */                                        
                                                                                
/*==================*                                                           
 | --HandleTheAck() |                                                           
 *==================*/                                                          
                                                                                
void HandleTheAck(AckIsADuplicate, DgramNum, AllAreBack)                        
int *AckIsADuplicate; int *DgramNum; int *AllAreBack;                           
{ int i,j;                                                                      
                                                                                
  if (monitor_the_monitor) printf("%d.",MsgBuf.dgram_num);                      
  *DgramNum = MsgBuf.dgram_num;                                                 
  j = *DgramNum % MAXwindowSIZE;                                                
  *AckIsADuplicate = (dgstatus[j].flags & dgsRECEIVEDackBACK);                  
  dgstatus[j].flags = dgstatus[j].flags | dgsRECEIVEDackBACK;                   
  ServerIsOnMVS       = MsgBuf.flags & FROMmvs;                                 
  QueueingIsAvailable = MsgBuf.flags & QUEUEINGisAVAILABLE;                     
  i = QueueingIsOn;                                                             
  QueueingIsOn        = MsgBuf.flags & QUEUEINGisON;                            
  if ( ( i  && !(MsgBuf.flags & QUEUEINGisON)) ||                               
      ((!i) && (MsgBuf.flags & QUEUEINGisON)))                                  
     UpdateServerStatus();                                                      
  if (!(*AckIsADuplicate))                                                      
     CalculateTurnaroundTime();                                                 
  if (somexdisplay)                                                             
     if ((MsgBuf.flags & STATISTICSfieldsVALID) ||                              
         (udploopbench && (MsgBuf.flags & REQUESTstatistics)))                  
       { if (sTATCount)                                                         
            SavedAccumTAT =                                                     
              (int)((float)SavedAccumTAT) / ((float)sTATCount);                 
         memcpy((char *)&Savedackbuf, (char *)&MsgBuf, MIBtopSIZE +             
                                                     sizeof(MibResponseType));  
      /* if (MonitorIsRunning && !BenchmarkIsRunning) <- only possible case */  
            PlotTheGoodStuff();                                     /* now  */  
                                                                                
         SavedAccumTAT = sTATCount = 0;                                         
       }                                                                        
  if (MsgBuf.dgram_length == -1)                                                
     *AllAreBack = 1;                                                           
} /* HandleTheAck() */                                                          
                                                                                
/*============================*                                                 
 | --KickSocketIntoBulkmode() |                                                 
 *============================*/                                                
                                                                                
#if defined(MVS)                                                                
                                                                                
void KickSocketIntoBulkmode(bulkmode, recvqlen, sendqlen, movedata,             
                            tststor, also_set_nonblock_local)                   
int bulkmode, recvqlen, sendqlen, movedata, tststor,                            
    also_set_nonblock_local;                                                    
{ int maxsendq, optlen, retcode;                                                
                                                                                
  msg(-3, "", "KickSocketIntoBulkmode():");                                     
                                                                                
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *            
   | For bulkmode sockets:                                         |            
   | If we're going to be returning ACKs to the sender, then       |            
   | we will want to setup a queue for outgoing datagrams as well. |            
   | First, find out what's available.                             |            
   * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */           
                                                                                
  maxsendq = DEFAULTsendQSIZE;                                                  
  if (bulkmode)                                                                 
    { optlen = sizeof(bulkstr);                                                 
                                                                                
      msg(3, "", "About to getibmsockopt().");                                  
      retcode =                                                                 
           getibmsockopt(s, SOL_SOCKET, SO_BULKMODE,                            
                         (unsigned char *) &bulkstr, &optlen);                  
      msg1(3, "Back from getibmsockopt(), sendqavail=%d.",                      
                                    bulkstr.b_max_send_queue_size_avail);       
      if (retcode < 0)                                                          
         oops("on getibmsockopt()");                                            
      maxsendq = bulkstr.b_max_send_queue_size_avail;                           
      if (maxsendq && !Silent)                                                  
        { printf("%s Using bulkmode send queue of %d bytes.\n",                 
                  msgp, maxsendq);                                              
        }                                                                       
    }                                                                           
                                                                                
  if (sendqlen > maxsendq)                                                      
     sendqlen = maxsendq;                                                       
                                                                                
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *            
   | OK, now we can set the socket into bulkmode.                  |            
   * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */           
  bulkstr.b_onoff = bulkmode;                                                   
  bulkstr.b_teststor = etststor;                                                
  bulkstr.b_max_receive_queue_size = recvqlen;                                  
  bulkstr.b_max_send_queue_size = sendqlen;                                     
  bulkstr.b_move_data = movedata;                                               
  optlen = sizeof(bulkstr);                                                     
  if (debug >= 3)                                                               
     SnapBulkstr();                                                             
  retcode =                                                                     
        setibmsockopt(s, SOL_SOCKET, SO_BULKMODE,                               
                      (unsigned char *) &bulkstr, optlen);                      
  msg(3, "", "Back from setibmsockopt().");                                     
  if (retcode < 0)                                                              
    { printf("%s Trying to set Recv Q=%d, Send Q=%d.\n",msgp,                   
              bulkstr.b_max_receive_queue_size,                                 
              bulkstr.b_max_send_queue_size);                                   
      QueueingIsAvailable = QueueingIsOn = FALSE;                               
      oops("on setibmsockopt()");                                               
    }                                                                           
  QueueingIsAvailable = TRUE;                                                   
  QueueingIsOn = bulkmode;                                                      
  QueueingOnReceives = bulkmode && recvqlen;                                    
  if (also_set_nonblock_local && QueueingOnReceives)                            
    { msg(3, "l-", "About to setibmsockopt(SO_NONBLOCKLOCAL on).");             
      retcode = setibmsockopt(s, SOL_SOCKET, SO_NONBLOCKLOCAL,                  
                              (unsigned char *) &one, sizeof(int));             
      msg(3, "", "Back from setibmsockopt(SO_NONBLOCKLOCAL on).");              
      if (retcode < 0)                                                          
         oops("on setibmsockopt(SO_NONBLOCKLOCAL on)");                         
      SocketIsLocalNonBlocking = 1;                                             
    }                                                                           
}  /* KickSocketIntoBulkmode() */                                               
#endif                                                                          
                                                                                
/*===================*                                                          
 | --MoveTheWindow() |                                                          
 *===================*/                                                         
                                                                                
void MoveTheWindow(i, WindowHasMoved, AllAreBack)                               
int i; int *WindowHasMoved; int *AllAreBack;                                    
{ int ii,j;                                                                     
  *WindowHasMoved = 0;                                                          
  if (MustReturnAllAcks)                                                        
    { nextburst = nextburst + 1;                                                
      if (nextburst == prevwindow)                                              
        { *WindowHasMoved = 1;                                                  
          suna = suna + prevwindow;                                             
        }                                                                       
    }                                                                           
    else { *WindowHasMoved = 1;                                                 
           ii = suna % MAXwindowSIZE;                                           
           for (j=suna; j<i+1; j=j+1)                                           
              { dgstatus[ii].flags = 0;                                         
                ii = (ii+1) % MAXwindowSIZE;                                    
              }                                                                 
           suna = i+1;                                                          
         }                                                                      
  if (suna >= (orignbuf + nlastbuf))                                            
     *AllAreBack = 1;                                                           
  if (*WindowHasMoved)                                                          
    { if (monitor_the_monitor) printf("w%d.", suna);                            
      msg1(2, "Moving window, new suna=%d.", suna);                             
    }                                                                           
}  /* MoveTheWindow() */                                                        
                                                                                
/*=============*                                                                
 | --msdelay() |                                                                
 *=============*/                                                               
                                                                                
msdelay(msec)                                                                   
int msec;                                                                       
{ int            i;                                                             
  struct fd_set  ready;                                                         
  int            retcode;                                                       
  double         t0, t1;                                                        
  struct timeval tv, tv0;                                                       
  struct timezone Tpz;                                                          
                                                                                
  if (msec < 0)                                                                 
    { if (debugt)                                                               
         printf("\n");                                                          
      return;                                                                   
    }                                                                           
  i = msec;                                                                     
                                                                                
  t0 = GetWallClockTimeInMicroseconds();                                        
                                                                                
 TryAgain2:                                                                     
  FD_ZERO((struct fd_set *)&ready);                                             
  FD_SET(0, (struct fd_set *)&ready);                                           
  tv.tv_sec = i / 1000;                                                         
  tv.tv_usec = (i % 1000) * 1000;                                               
                                                                                
#if defined(MVS)                                                                
#if defined(USEtcpip)                                                           
  retcode = select(0, (fd_set *)&ready, (fd_set *)0,                            
                   (fd_set *)0, (struct timeval *)&tv);                         
#else /* it's not USEtcp */                                                     
  retcode = 0;                                                                  
#endif /* USEtcpip */                                                           
#else /* it's not MVS */                                                        
#if defined(OS2)                                                                
  { int  just_one, i1;                                                          
    long l1;                                                                    
    just_one = 1;                                                               
    memcpy(&i1, &ready, sizeof(int));                                           
                                                                                
    l1 = 1; /* ??? */                                                           
                                                                                
#if defined(USEtcpip)                                                           
    retcode = select(&just_one, i1, 0, 0, l1);                                  
#else /* it's not USEtcpip */                                                   
    retcode = 0;                                                                
#endif /* USEtcpip */                                                           
  }                                                                             
#else /* it's not OS2 */                                                        
#if defined(USEtcpip)                                                           
  retcode = select(1, (fd_set *)&ready, (fd_set *)0,                            
                   (fd_set *)0, (struct timeval *)&tv);                         
#else /* it's not USEtcpip */                                                   
  retcode = 0;                                                                  
#endif /* USEtcpip */                                                           
#endif /* OS2 */                                                                
#endif /* MVS */                                                                
                                                                                
  if (retcode < 0)                                                              
#if defined(OS2)                                                                
    { oops("on select() in msdelay()"); }                                       
#else                                                                           
     if (errno == EINTR)                                                        
       { t1 = GetWallClockTimeInMicroseconds();                                 
         t1 = t1 - t0;                                                          
         if (t1 < 950000.0)                                                     
           { gettimeofday(&tv0, &Tpz);                                          
             i = (1000000 - tv0.tv_usec) / 1000;                                
             if (i > MINselectTIME)                                             
               { if (debugt)                                                    
                   { printf("\nmsdelay: select() saw EINTR, ET=%.6f,",          
                            t1/1000000.0);                                      
                     printf(                                                    
                      " %d ms. more in cycle, going to select() again.\n", i);  
                   }                                                            
                 goto TryAgain2;                                                
               }                                                                
               else                                                             
               if (debugt)                                                      
                 { printf("\nmsdelay: select() saw EINTR, ET=%.6f,",            
                          t1/1000000.0);                                        
                   printf(                                                      
                  " %d ms. more in cycle, no point in restarting select().\n",  
                          i);                                                   
                 }                                                              
           }                                                                    
           else                                                                 
               if (debugt)                                                      
                 { printf("\nmsdelay: select() saw EINTR, ET=%.6f,",            
                          t1/1000000.0);                                        
                   printf(" no point in restarting select().\n");               
                 }                                                              
       }                                                                        
       else                                                                     
       { oops("on select() in msdelay()"); }                                    
#endif                                                                          
                                                                                
}  /* msdelay() */                                                              
                                                                                
/*====================*                                                         
 | --NormalShutdown() |                                                         
 *====================*/                                                        
                                                                                
void NormalShutdown()                                                           
{ CloseSoc();              /* Close the socket first.                  */       
                                                                                
  if (receiver && montcpip) /* Don't close the monitor connection      */       
                            /* before closing the socket.. otherwise   */       
     CloseMonConnection(); /* the IUCV interrupt for the close() does  */       
                           /* not get presented to this virtual machine*/       
} /* NormalShutdown() */                                                        
                                                                                
/*==============*                                                               
 | --OpenRecv() |                                                               
 *==============*/                                                              
                                                                                
void OpenRecv()                                                                 
{ int i;                                                                        
                                                                                
  msg(-3, "", "About to call socket().");                                       
                                                                                
  if (usetcp)                                                                   
#if defined(USEtcpip)                                                           
    { s = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);                            
#else                                                                           
    { s = 0;                                                                    
#endif                                                                          
      if (s < 0)                                                                
        { oops(strcat(msgp," unable to allocate socket")); }                    
    }                                                                           
    else                                                                        
#if defined(USEtcpip)                                                           
    { s = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);                             
#else                                                                           
    { s = 0;                                                                    
#endif                                                                          
      if (s < 0)                                                                
        { oops(strcat(msgp," unable to allocate socket")); }                    
    }                                                                           
  msg(3, "", "Back from socket().");                                            
  lsocklen = sizeof(lsock);                                                     
  lsock.sin_family = AF_INET;                                                   
  lsock.sin_port = htons(port);                                                 
  lsock.sin_addr.s_addr = INADDR_ANY;                                           
  rsocklen = sizeof(rsock);                                                     
  rsock.sin_family = AF_INET;                                                   
  rsock.sin_port = 0;                                                           
  rsock.sin_addr.s_addr = INADDR_ANY;                                           
                                                                                
  msg(-3, "", "About to call bind().");                                         
#if defined(USEtcpip)                                                           
  if (0 != bind(s, (struct sockaddr *)&lsock, sizeof(lsock)) )                  
     oops(strcat(msgp," unable to bind socket"));                               
#endif                                                                          
  msg(3, "", "Back from bind().");                                              
                                                                                
/*if (reliable)                                                                 
    { msg(-3, "-.", "About to ioctl(FIONBIO).");                                
      if (ioctl(s, FIONBIO, (char *) &one) < 0)                                 
         oops("on ioctl()");                                                    
      msg(3, "", "Back from ioctl(FIONBIO).");                                  
    }                                                                           
*/                                                                              
                                                                                
#if defined(MVS)                                                                
{ }                                                                             
#else                                                                           
#if defined(USEtcpip)                                                           
  if (setsockopt(s, SOL_SOCKET, SO_RCVBUF, (char *)&sorcvbuf,                   
                                     sizeof(sorcvbuf)) < 0)                     
     oops("setsockopt(SO_SNDBUF)");                                             
  if (setsockopt(s, SOL_SOCKET, SO_SNDBUF, (char *)&sosndbuf,                   
                                     sizeof(sosndbuf)) < 0)                     
     oops("setsockopt(SO_SNDBUF)");                                             
#endif /* USEtcpip */                                                           
#endif                                                                          
                                                                                
  for (i=0; i<MAXwindowSIZE; i=i+1)                                             
      pattern((short int *)&MsgBufs[i], buflen, (short int)i);                  
                                                                                
} /* OpenRecv() */                                                              
                                                                                
/*==============*                                                               
 | --OpenSend() |                                                               
 *==============*/                                                              
                                                                                
void OpenSend()                                                                 
{ int i;                                                                        
                                                                                
  bzero((char *)&rsock, sizeof(rsock));                                         
  rsocklen = sizeof(rsock);                                                     
  rsock.sin_port = htons(port);                                                 
  if (atoi(hostname) > 0)                                                       
    { /* host number */                                                         
     msg(3, "", "A host number was specified.");                                
     msg(3, "", "About to call inet_addr.");                                    
     rsock.sin_family = AF_INET;                                                
#if defined(USEtcpip)                                                           
     rsock.sin_addr.s_addr = (unsigned long)inet_addr(hostname);                
#endif                                                                          
     msg1(3, "sin_addr.s_addr=%08X.", rsock.sin_addr.s_addr);                   
    }                                                                           
  else                                                                          
    { /* host name */                                                           
     if (debug >= 3)                                                            
       { printf("%s A host name was specified.", msgp);                         
         printf(" About to gethostbyname(), hostname is %s.\n", hostname);      
       }                                                                        
#if defined(USEtcpip)                                                           
     if (NULL == (addr = gethostbyname(hostname)) )                             
       { printf("hostname is in error\n");                                      
         printf("%s unable to resolve %s\n", msgp, hostname);                   
         exit(-1);                                                              
       }                                                                        
#else                                                                           
     printf ("No gethostbyname()\n");                                           
#endif                                                                          
     rsock.sin_family = addr->h_addrtype;                                       
     rsock.sin_addr.s_addr =                                                    
              *((unsigned long *) addr->h_addr_list[0] );                       
    }                                                                           
                                                                                
  bzero((char *)&lsock, sizeof(lsock));                                         
  lsocklen = sizeof(lsock);                                                     
  lsock.sin_family = AF_INET;                                                   
  lsock.sin_port = 0;                                                           
  lsock.sin_addr.s_addr = INADDR_ANY;                                           
                                                                                
  msg1(-3, "About to call socket(), usetcp=%d.",usetcp);                        
                                                                                
#if defined(USEtcpip)                                                           
  if (usetcp)                                                                   
     if (-1 == (s = socket(AF_INET, SOCK_STREAM, 0)) )                          
       { oops(strcat(msgp," unable to allocate socket")); }                     
       else ;                                                                   
     else                                                                       
     { s = socket(AF_INET, SOCK_DGRAM, 0);                                      
       if (s < 0)                                                               
         { oops(strcat(msgp," unable to allocate socket")); }                   
     }                                                                          
#else                                                                           
  s = 0;                                                                        
#endif                                                                          
                                                                                
  msg(3, "", "Back from socket().");                                            
                                                                                
  lsocklen = sizeof(lsock);                                                     
                                                                                
  msg(-3, "", "About to call bind().");                                         
#if defined(USEtcpip)                                                           
  if (0 != bind(s, (struct sockaddr *)&lsock, sizeof(lsock)) )                  
     oops(strcat(msgp," unable to bind socket"));                               
#endif                                                                          
  msg(3, "", "Back from bind().");                                              
                                                                                
  if (reliable || (somexdisplay && !usexbench))                                 
    { msg(-3, "-.", "About to ioctl(FIONBIO).");                                
#if defined(OS2)                                                                
#if defined(USEtcpip)                                                           
      ioctl(s, FIONBIO, (char *) &one, 0); /* ??? */                            
#endif                                                                          
#else                                                                           
#if defined(USEtcpip)                                                           
      if (ioctl(s, FIONBIO, (char *) &one) < 0)                                 
         oops("on ioctl()");                                                    
#endif                                                                          
#endif                                                                          
      msg(3, "", "Back from ioctl(FIONBIO).");                                  
    }                                                                           
                                                                                
#if defined(MVS)                                                                
  if (bulkmode)                                                                 
    { int optlen, retcode;                                                      
      optlen = sizeof(bulkstr);                                                 
      retcode = getibmsockopt(s, SOL_SOCKET, SO_BULKMODE,                       
                              (unsigned char *) &bulkstr, &optlen);             
      if (retcode < 0)                                                          
         oops("on getibmsockopt()");                                            
      if (sendqlen)                                                             
         if (bulkstr.b_max_send_queue_size_avail < sendqlen)                    
           { printf(                                                            
               "%s oops, the value you specified on -q is too large.\n",        
               msgp);                                                           
             printf("%s TCPIP is configured for only up to %d.\n",              
                     msgp, bulkstr.b_max_send_queue_size_avail);                
             printf("%s Please respecify.\n");                                  
             exit(-1);                                                          
           }                                                                    
           else { }                                                             
         else sendqlen = bulkstr.b_max_send_queue_size_avail;                   
    }                                                                           
#else                                                                           
#if defined(USEtcpip)                                                           
  if (setsockopt(s, SOL_SOCKET, SO_RCVBUF, (char *)&sorcvbuf,                   
                                     sizeof(sorcvbuf)) < 0)                     
     oops("setsockopt(SO_RCVBUF)");                                             
  if (setsockopt(s, SOL_SOCKET, SO_SNDBUF, (char *)&sosndbuf,                   
                                     sizeof(sosndbuf)) < 0)                     
     oops("setsockopt(SO_SNDBUF)");                                             
#endif /* USEtcpip */                                                           
#endif                                                                          
                                                                                
  for (i=0; i<MAXwindowSIZE; i=i+1)                                             
      pattern((short int *)&MsgBufs[i], buflen, (short int)i);                  
                                                                                
} /* OpenSend() */                                                              
                                                                                
/*==============*                                                               
 | --ParseOut() |                                                               
 *==============*/                                                              
                                                                                
int ParseOut(buf, s, minutesseconds_or_integer)                                 
char *buf; char *s; parse_types minutesseconds_or_integer;                      
{ int i; char *p; char *q;                                                      
  if ((p = (char *)strstr(buf, s)) == NULL)                                     
    { printf("Could not find the string, %s, in buffer!\n",s);                  
      exit(-1);                                                                 
    }                                                                           
  if (minutesseconds_or_integer == min_sec)                                     
    { p = p + strlen(s); q = (char *)strstr(p, ":");                            
      i = atoi(strncpy(p, p, q-p)) * 60;                                        
      p = q;                                                                    
    }                                                                           
    else i = 0;                                                                 
  q = p = (char *)strpbrk(p, "01234567890");                                    
  while (((*q) != ' ') && ((*q) != '\n') && ((*q) != '\0'))                     
     q = q + 1;                                                                 
  i= i + atoi(strncpy(p, p, q-p));                                              
  return(i);                                                                    
}  /* ParseOut() */                                                             
                                                                                
/*=============*                                                                
 | --pattern() |                                                                
 *=============*/                                                               
                                                                                
pattern(cp, cnt, tag)                                                           
   short int *cp;                                                               
   int cnt;                                                                     
   short int tag;                                                               
{ short int c = 0;                                                              
  int i;                                                                        
  /* msg3(4, "pattern(): cp=%8X, cnt=%4X, tag=%4X.", cp, cnt, tag); */          
  for (i=0; i<cnt/4; i=i+2)                                                     
    { *(cp+i) = tag;                                                            
      *(cp+i+1) = c+3;                                                          
      c = (c+4) % 65536;                                                        
    }                                                                           
}  /* pattern() */                                                              
                                                                                
/*================*                                                             
 | --PrintDgram() |                                                             
 *================*/                                                            
                                                                                
void PrintDgram(p_dgram)                                                        
dgram_format *p_dgram;                                                          
{ int j; char *p;                                                               
  p = (char *) p_dgram;                                                         
  if (debug < 77) return;                                                       
  printf(" buffer is at %08X, data=\n", p);                                     
  if (debug >= 99)                                                              
     j = buflen;                                                                
     else if (debug >= 88)                                                      
             j = max(rmsglen, smsglen);                                         
             else j = min(max(rmsglen, smsglen), RESETserverSIZE);              
  DumpStg((int *)p, j);                                                         
  printf("\n");                                                                 
} /* PrintDgram() */                                                            
                                                                                
/*=======================*                                                      
 | --Readgetibmsockopt() |                                                      
 *=======================*/                                                     
                                                                                
void Readgetibmsockopt()                                                        
{                                                                               
#if defined(MVS)                                                                
  int optlen, retcode;                                                          
  if (bulkmode)                                                                 
    { optlen = sizeof(bulkstr);                                                 
      retcode =                                                                 
           getibmsockopt(s, SOL_SOCKET, SO_BULKMODE,                            
                         (unsigned char *) &bulkstr, &optlen);                  
      if (retcode < 0)                                                          
         oops("on getibmsockopt()");                                            
    }                                                                           
#endif                                                                          
} /* Readgetibmsockopt() */                                                     
                                                                                
/*=============*                                                                
 | --Receive() |                                                                
 *=============*/                                                               
                                                                                
void Receive()                                                                  
{ int retcode;                                                                  
  float usecPerDgram, CombinedAverageUtil,                                      
        ServerUsefulDgramPerSec,                                                
        ServerTotalDgramPerSec, ServerTotalMBS,                                 
        ClientUsefulDgramPerSec, ClientUtil,                                    
     /* ClientTotalDgramPerSec, ClientTotalMBS, */                              
     /* CombinedTotalDgramPerSec, CombinedTotalMBS, */                          
        CombinedUsefulDgramPerSec, /* CombinedUsefulMBS, */                     
        fAverageElapsedTime, fServerTT3, fClientTT3,                            
        fServerUsefulDgrams, fClientUsefulDgrams,                               
        fServerElapsedTime;                                                     
  int ClientIsOnMVS,                                                            
      ClientIsOnIX, ServerIsOnIX, ServerElapsedTime;                            
  double ServerStartTime, ServerEndTime;                                        
  unsigned int ServerTotalDgrams, ClientTotalDgrams,                            
               ServerTotalBytes,                                                
             /*ClientTotalBytes,*/                                              
             /*CombinedUsefulBytes,*/                                           
               CombinedUsefulDgrams,                                            
             /*CombinedTotalBytes,*/                                            
               CombinedTotalDgrams;                                             
                                                                                
  do { if (!QueueingOnReceives)                                                 
         { if (reliable || montcpip)                                            
              SendAnyAcksBack();                                                
           if (pacing)                                                          
              msdelay(pacing);                                                  
           retcode = TryABlockingRecv(); /*(3)*/                                
           if (retcode < 0)                                                     
              exit(-1);                                                         
         }  /* else-part of if (reliable) */                                    
         else /* if (!QueueingOnReceives) */                                    
         { retcode = TNLocalNonBlockingAndTryRecv(); /*(2)*/                    
                                                                                
           if (retcode < 0)                                                     
#if defined(OS2)                                                                
             { oops("on the non-blocking recvfrom()"); }                        
#else                                                                           
              if (errno == EWOULDBLOCK)                                         
                { if (reliable || montcpip)                                     
                    { SendAnyAcksBack();                                        
                      if (pacing)                                               
                          msdelay(pacing);                                      
                      retcode = TFLocalNonBlockingAndRecv(); /*(1)*/            
                    }                                                           
                    else                                                        
                    retcode = TFLocalNonBlockingAndRecv(); /*(1)*/              
                }   /* if (errno == EWOULDBLOCK) */                             
                else { oops("on the non-blocking recvfrom()"); }                
#endif                                                                          
                                                                                
         }                                                                      
                                                                                
       if (retcode == 0)                                                        
          printf("%s retcode=0, probable error!\n",msgp);                       
                                                                                
       if (monitor_the_monitor)                                                 
          printf("%d.", MsgBuf.dgram_num);                                      
                                                                                
       if (!(MsgBuf.flags & LASTdgram))                                         
          if (MsgBuf.dgram_length >= 24)                                        
             if (MsgBuf.AccumBlockingReceives !=                                
                 (((MsgBuf.dgram_num % MAXwindowSIZE) << 16) | 0x17))           
                printf("ohoh! dgram_num=%d, len=%d.\n",                         
                       MsgBuf.dgram_num,retcode);                               
                                                                                
       if (MsgBuf.flags & REQUESTstatistics)                                    
          RequestStatisticsOnNextDgram = TRUE;                                  
                                                                                
       if (MsgBuf.flags & REQUESTnetstat)                                       
       { printf("RequestNetstat flag was on\n");                                
          RequestNetstatOnNextDgram = TRUE;                                     
       }                                                                        
                                                                                
       if (MsgBuf.flags & RESETserver)                                          
         { Silent = (MsgBuf.flags & USINGxDISPLAY);                             
           recvqlen = (rmsglen + 24) * MsgBuf.NewRecvQSize;                     
           if (MsgBuf.NewSendQSize > 0)                                         
              sendqlen = 8 + (smsglen + 28 ) * MsgBuf.NewSendQSize;             
              else sendqlen = 0;                                                
           etststor = 0;                                                        
           acklen = MsgBuf.NewAckLen;                                           
#if defined(MVS)                                                                
           ResetServer(bulkmode);                                               
#else                                                                           
           ResetServer();                                                       
#endif                                                                          
         }                                                                      
                                                                                
       if (MsgBuf.flags & TOGGLEqueueing)                                       
         { NewQueueing = (QueueingIsOn + 1) % 2;                                
           recvqlen = (rmsglen + 24) * MsgBuf.NewRecvQSize;                     
           if (MsgBuf.NewSendQSize > 0)                                         
              sendqlen = 8 + (smsglen + 28 ) * MsgBuf.NewSendQSize;             
              else sendqlen = 0;                                                
#if defined(MVS)                                                                
           ResetServerBulkmode(NewQueueing);                                    
#endif                                                                          
         }                                                                      
                                                                                
       if (MsgBuf.flags & CHANGEackLEN)                                         
          acklen = MsgBuf.NewAckLen;                                            
       if (MsgBuf.flags & CHANGEpacing)                                         
          pacing = MsgBuf.NewPacing;                                            
                                                                                
       if (MsgBuf.flags & CHANGEqueueing)                                       
         { recvqlen = (rmsglen + 24) * MsgBuf.NewRecvQSize;                     
           if (MsgBuf.NewSendQSize > 0)                                         
              sendqlen = 8 + (smsglen + 28 ) * MsgBuf.NewSendQSize;             
              else sendqlen = 0;                                                
#if defined(MVS)                                                                
           if (QueueingIsOn)                                                    
              ResetServerBulkmode(QueueingIsOn);                                
#endif                                                                          
         }                                                                      
                                                                                
       if (nbufrcvd == 1)                                                       
          ServerStartTime = GetWallClockTimeInMicroseconds();                   
                                                                                
       msg2(3, "So far, %d messages received, %d bytes received.",              
             nbufrcvd, nbytrcvd);                                               
                                                                                
       if (reliable)                                                            
          RecordMessageHasArrived(MsgBuf.dgram_num);                            
       else if (montcpip)                                                       
              { RecordMessageHasArrived(0);                                     
                AckToSend = MsgBuf.dgram_num;                                   
              }                                                                 
                                                                                
     } while ( (montcpip && !reliable) ||                                       
              ((nbufrcvd <= orignbuf) &&     /* the big do-while loop */        
                !(MsgBuf.flags & (LASTdgram | SHUTDOWNonLASTdgram))) );         
                                                                                
  if (reliable || montcpip )                                                    
     SendAnyAcksBack();                                                         
                                                                                
  if (bulkmode && (reliable || montcpip))                                       
     FlushOutboundQueue();                                                      
                                                                                
  GetServerCurrentTime();                                                       
                                                                                
  if (monitor_the_monitor)                                                      
     printf("\n");                                                              
                                                                                
  if (debug >= 2)                                                               
     SnapLastMessage();                                                         
                                                                                
 /*******************************************************                       
  * Figure out configuration                            *                       
  *******************************************************/                      
                                                                                
  ClientIsOnMVS = MsgBuf.flags & FROMmvs;                                       
  ClientIsOnIX  = MsgBuf.flags & FROMunixHOST;                                  
  ServerIsOnMVS = WHATiAM & FROMmvs;                                            
  ServerIsOnIX  = WHATiAM & FROMunixHOST;                                       
                                                                                
  if ( ( ClientIsOnMVS     &&  ServerIsOnMVS)      ||                           
       (!ClientIsOnMVS     && !ServerIsOnMVS))                                  
     LetsAssumeLoopback = 1;                                                    
     else LetsAssumeLoopback = 0;                                               
                                                                                
 /*******************************************************                       
  * Figure out the basic counts and rates.              *                       
  *******************************************************/                      
                                                                                
  ServerEndTime = GetWallClockTimeInMicroseconds();                             
  ServerElapsedTime = (int)(ServerEndTime - ServerStartTime);                   
  fServerElapsedTime = (float)ServerElapsedTime;                                
                                                                                
  /* MsgBuf.cpu_time and MsgBuf.elapsed_time are in microseconds. */            
  fRecvTT3 = (float)RecvTT3;                                                    
  SendTT3 = MsgBuf.cpu_time;                                                    
  fSendTT3 = (float)SendTT3;                                                    
  ClientElapsedTime = MsgBuf.elapsed_time;                                      
  fClientElapsedTime = (float)ClientElapsedTime;                                
                                                                                
  if (LetsAssumeLoopback)                                                       
     fServerTT3 = ((float)RecvTT3) + ((float)TcpTT3) / 2.0;                     
     else fServerTT3 = ((float)RecvTT3) + ((float)TcpTT3);                      
  fServerUsefulDgrams = (float)nbufrcvd;                                        
  ServerTotalDgrams = nbufsent + nbufrcvd;                                      
  ServerUsefulBytes = nbytrcvd;                                                 
  ServerTotalBytes = nbytsent + nbytrcvd;                                       
                                                                                
  fClientTT3 = (float)SendTT3;                                                  
  fClientUsefulDgrams = (float)MsgBuf.nbufsent;                                 
  ClientTotalDgrams = MsgBuf.nbufsent + MsgBuf.nbufrcvd;                        
  ClientUsefulBytes = MsgBuf.nbytsent;                                          
/*ClientTotalBytes = MsgBuf.nbytsent + MsgBuf.nbytrcvd;*/                       
                                                                                
  TotTT3 = RecvTT3 + SendTT3 + TcpTT3;                                          
  fTotTT3 = (float)TotTT3;                                                      
                                                                                
  CombinedTotalDgrams = MsgBuf.nbufsent + MsgBuf.nbufrcvd + MsgBuf.nbufrsnt +   
              nbufsent + nbufrcvd + nbufrsnt;                                   
/*CombinedTotalBytes = MsgBuf.nbytsent + MsgBuf.nbytrcvd + MsgBuf.nbytrsnt +    
              nbytsent + nbytrcvd + nbytrsnt;*/                                 
                                                                                
  CombinedUsefulDgrams = MsgBuf.nbufsent + nbufrcvd;                            
/*CombinedUsefulBytes = MsgBuf.nbytsent + nbytrcvd;*/                           
                                                                                
  if (ServerElapsedTime > 0)                                                    
    { if ((fRecvTT3 + fTcpTT3) > 0)                                             
         if (LetsAssumeLoopback)                                                
            ServerUtil = (fRecvTT3 + fTcpTT3/2.0) / fServerElapsedTime;         
            else ServerUtil = (fRecvTT3 + fTcpTT3) / fServerElapsedTime;        
         else ServerUtil = -1.0;                                                
      ServerUsefulMBS = ((float)ServerUsefulBytes) / fServerElapsedTime;        
      ServerTotalMBS = ((float)ServerTotalBytes) / fServerElapsedTime;          
      ServerUsefulDgramPerSec = fServerUsefulDgrams /                           
                             (fServerElapsedTime / 1000000.0);                  
      ServerTotalDgramPerSec = ((float)ServerTotalDgrams) /                     
                                  (fServerElapsedTime / 1000000.0);             
    }                                                                           
    else ServerUtil = ServerUsefulMBS = ServerUsefulDgramPerSec =               
                      ServerTotalMBS = ServerTotalDgramPerSec = -1.0;           
                                                                                
  if (ClientElapsedTime > 0)                                                    
    { if (ClientIsOnMVS)                                                        
         ClientUtil = (fSendTT3 + fTcpTT3/2.0) / fClientElapsedTime;            
         else ClientUtil = fSendTT3 / fClientElapsedTime;                       
      ClientUsefulMBS = ((float)ClientUsefulBytes) / fClientElapsedTime;        
   /* ClientTotalMBS = ((float)ClientTotalBytes) / fClientElapsedTime; */       
      ClientUsefulDgramPerSec = fClientUsefulDgrams /                           
                           (fClientElapsedTime / 1000000.0);                    
   /* ClientTotalDgramPerSec = ((float)ClientTotalDgrams) /                     
                           (fClientElapsedTime / 1000000.0); */                 
    }                                                                           
    else ClientUtil = ClientUsefulMBS = ClientUsefulDgramPerSec = -1.0;         
                   /* ClientTotalMBS = ClientTotalDgramPerSec = -1.0; */        
                                                                                
  if (ClientElapsedTime || ServerElapsedTime)                                   
    { fAverageElapsedTime =                                                     
                    (fServerElapsedTime + fClientElapsedTime)/2.0;              
      CombinedAverageUtil = ((float)TotTT3) / fAverageElapsedTime;              
   /* CombinedUsefulMBS = ((float)CombinedUsefulBytes) /                        
                                      fAverageElapsedTime; */                   
      CombinedUsefulDgramPerSec = ((float)CombinedUsefulDgrams) /               
                                (fAverageElapsedTime / 1000000.0);              
   /* CombinedTotalMBS = ((float)CombinedTotalBytes) /                          
                                      fAverageElapsedTime; */                   
   /* CombinedTotalDgramPerSec = ((float)CombinedTotalDgrams) /                 
                                (fAverageElapsedTime / 1000000.0); */           
    }                                                                           
    else                                                                        
    { fAverageElapsedTime = CombinedAverageUtil = -1.0;                         
   /* CombinedUsefulMBS = CombinedUsefulDgramPerSec = -1.0; */                  
   /* CombinedTotalMBS = CombinedTotalDgramPerSec = -1.0; */                    
    }                                                                           
                                                                                
  printf("%s Done.\n",msgp);                                                    
                                                                                
 /*******************************************************                       
  * Server Report                                       *                       
  *******************************************************/                      
                                                                                
  printf("%s Server says: Recv'd %d dgrams, %d bytes",                          
          msgp, nbufrcvd, nbytrcvd);                                            
                                                                                
  if (reliable)                                                                 
    { printf(", saw %d duplicates.\n", nduprcvd);                               
      printf("%s              Sent %d %d-byte ACKs back,",                      
              msgp, nbufsent, acklen);                                          
      printf(" %5.1f datagrams/ACK.\n",                                         
                     ((float)nbufrcvd)/((float)nbufsent));                      
    }                                                                           
    else printf(".\n");                                                         
                                                                                
#if defined(MVS)                                                                
  { int optlen, retcode;                                                        
    if (bulkmode)                                                               
      { optlen = sizeof(bulkstr);                                               
        retcode =                                                               
             getibmsockopt(s, SOL_SOCKET, SO_BULKMODE,                          
                           (unsigned char *) &bulkstr, &optlen);                
        if (bulkstr.b_num_IUCVs_received > 0)                                   
          { printf("%s              Recv: %d IUCVs",                            
                    msgp, bulkstr.b_num_IUCVs_received);                        
             printf(", %6.0f bytes/IUCV, %6.2f dgrams/IUCV.\n",                 
                 ((float)nbytrcvd)/((float)bulkstr.b_num_IUCVs_received),       
                 ((float)nbufrcvd)/((float)bulkstr.b_num_IUCVs_received));      
          }                                                                     
        if (bulkstr.b_num_IUCVs_sent > 0)                                       
          { printf("%s              Send: %d IUCVs",                            
                    msgp, bulkstr.b_num_IUCVs_sent);                            
            printf(", %6.0f bytes/IUCV, %6.2f dgrams/IUCV.\n",                  
                     ((float)nbytsent)/((float)bulkstr.b_num_IUCVs_sent),       
                     ((float)nbufsent)/((float)bulkstr.b_num_IUCVs_sent));      
          }                                                                     
      }                                                                         
    if (TcpIO3)                                                                 
      { printf("%s              TCPIP: %d IOs", msgp, TcpIO3);                  
        if (LetsAssumeLoopback)                                                 
           printf(".\n");                                                       
           else printf(", %6.0f bytes/IO, %6.2f dgrams/IO.\n",                  
                          ((float)ServerTotalBytes)/fTcpIO3,                    
                          ((float)ServerTotalDgrams)/fTcpIO3);                  
      }                                                                         
  }                                                                             
#endif                                                                          
                                                                                
  if (ServerUsefulMBS >= 0)                                                     
    { printf("%s              Elapsed Time=%8.3f seconds,",                     
              msgp, fServerElapsedTime / 1000000.0);                            
      printf(" Datarate=%7.3f MBS.\n", ServerUsefulMBS);                        
    }                                                                           
    else printf("%s              Elapsed Time=%8.3f seconds.\n",                
                 msgp, fServerElapsedTime/1000000.0);                           
                                                                                
  if ( (ServerUsefulDgramPerSec > 0) &&                                         
       (reliable || (nbufrcvd == MsgBuf.nbufsent)) )                            
     { printf("%s              %d (useful) datagrams/second",                   
               msgp, (int)ServerUsefulDgramPerSec);                             
#if !defined(MVS)                                                               
       if (ServerUtil > 0.0001)                                                 
          printf(" at %5.1f%% CPU utilization.\n", ServerUtil * 100.0);         
          else printf(".\n");                                                   
#else                                                                           
       printf(".\n");                                                           
#endif                                                                          
     }                                                                          
                                                                                
  if (ServerIsOnMVS)                                                            
     printf("%s              It is running on an MVS host.\n",msgp);            
  if (ServerIsOnIX)                                                             
     printf("%s              It is running on an *IX host.\n", msgp);           
                                                                                
 /*******************************************************                       
  * Client Report                                       *                       
  *******************************************************/                      
                                                                                
  printf("%s Client says: Sent %d datagrams", msgp, MsgBuf.nbufsent);           
                                                                                
  if (reliable)                                                                 
    { printf(", %d timeouts, resent %d.\n",                                     
              MsgBuf.ntimeout, MsgBuf.nbufrsnt);                                
      printf("%s              Recv'd %d ACKs back,",                            
              msgp, MsgBuf.nbufrcvd);                                           
      printf(" saw %d duplicates.\n", MsgBuf.nduprcvd);                         
      printf(                                                                   
     "%s                      (does not include ACK for final dgram)\n",        
          msgp);                                                                
    }                                                                           
    else printf(".\n");                                                         
                                                                                
  if (MsgBuf.nIUCVrcvd > 0)                                                     
    { printf("%s              Recv: %d IUCVs,", msgp, MsgBuf.nIUCVrcvd);        
      printf(" %6.0f bytes/IUCV, %6.2f dgrams/IUCV.\n",                         
               (((float)MsgBuf.nbytrcvd) / ((float)MsgBuf.nIUCVrcvd)),          
               (((float)MsgBuf.nbufrcvd) / ((float)MsgBuf.nIUCVrcvd)));         
    }                                                                           
  if (bulkmode && (MsgBuf.nIUCVsent > 0))                                       
    { printf("%s              Send: %d IUCVs,", msgp, MsgBuf.nIUCVsent);        
      printf(" %6.0f bytes/IUCV, %6.2f dgrams/IUCV.\n",                         
               (((float)MsgBuf.nbytsent) / ((float)MsgBuf.nIUCVsent)),          
               (((float)MsgBuf.nbufsent) / ((float)MsgBuf.nIUCVsent)));         
    }                                                                           
                                                                                
  if (ClientUsefulMBS >= 0)                                                     
    { printf("%s              Elapsed Time=%8.3f seconds,",                     
              msgp, fClientElapsedTime/1000000.0);                              
      printf(" Datarate=%7.3f MBS.\n", ClientUsefulMBS);                        
    }                                                                           
    else printf("%s              Elapsed Time=%8.3f seconds.\n",                
                 msgp, fClientElapsedTime/1000000.0);                           
                                                                                
  if ( (ClientUsefulDgramPerSec > 0) &&                                         
       (reliable || (nbufrcvd == MsgBuf.nbufsent)) )                            
    { printf("%s              %d (useful) datagrams/second",                    
              msgp, (int)ClientUsefulDgramPerSec);                              
#if !defined(MVS)                                                               
      if (ClientUtil > 0.0001)                                                  
         printf(" at %5.1f%% CPU utilization.\n", ClientUtil * 100.0);          
         else printf(".\n");                                                    
#else                                                                           
      printf(".\n");                                                            
#endif                                                                          
    }                                                                           
                                                                                
  if (ClientIsOnMVS)                                                            
     printf("%s              It is running on an MVS host.\n",msgp);            
  if (ClientIsOnIX)                                                             
     printf("%s              It is running on an *IX host.\n", msgp);           
                                                                                
 /*******************************************************                       
  * Summary Report                                      *                       
  *******************************************************/                      
                                                                                
#if !defined(MVS)                                                               
  if (ServerIsOnMVS)                                                            
     printf("%s Summary:     CPU Seconds: Server=%3.0f,",                       
             msgp, ((float)RecvTT3)/1000000.0);                                 
     else printf("%s Summary:     CPU Seconds: Server=%7.3f,",                  
                  msgp, ((float)RecvTT3)/1000000.0);                            
                                                                                
  if (ClientIsOnMVS)                                                            
     printf(" Client=%3.0f", ((float)SendTT3)/1000000.0);                       
     else printf(" Client=%7.3f", ((float)SendTT3)/1000000.0);                  
                                                                                
  if (ServerIsOnMVS)                                                            
     printf(", Host TCPIP=%3.0f.\n", ((float)TcpTT3)/1000000.0);                
     else printf(".\n");                                                        
#endif                                                                          
                                                                                
#if defined(MVS)                                                                
  if (LetsAssumeLoopback)                                                       
     if ( (CombinedUsefulDgramPerSec > 0) &&                                    
          (reliable || (nbufrcvd == MsgBuf.nbufsent)) )                         
       { printf("%s Summary:     %d datagrams/second.\n",                       
                msgp, (int)CombinedUsefulDgramPerSec);                          
       }                                                                        
#else                                                                           
  if (LetsAssumeLoopback)                                                       
     if ( (CombinedUsefulDgramPerSec > 0) &&                                    
          (reliable || (nbufrcvd == MsgBuf.nbufsent)) )                         
       { printf("%s              %d datagrams/second",                          
                msgp, (int)CombinedUsefulDgramPerSec);                          
         if (CombinedAverageUtil > 0.0001)                                      
            printf(" at %5.1f%% CPU utilization.\n",                            
                    CombinedAverageUtil * 100.0);                               
            else printf(".\n");                                                 
       }                                                                        
#endif                                                                          
                                                                                
#if !defined(MVS)                                                               
  if (!LetsAssumeLoopback && (fServerTT3 > 0.000001))                           
    { usecPerDgram = fServerTT3 / ((float)ServerTotalDgrams);                   
      printf(                                                                   
      "%s                  Server+HostTCPIP : %d usec/dgram.\n",                
                                               msgp, (int)usecPerDgram);        
    }                                                                           
  if (!LetsAssumeLoopback && (fClientTT3 > 0.000001))                           
    { usecPerDgram = fClientTT3 / ((float)ClientTotalDgrams);                   
      printf(                                                                   
      "%s                  Client           : %d usec/dgram.\n",                
                                               msgp, (int)usecPerDgram);        
    }                                                                           
  if (LetsAssumeLoopback && (TotTT3 > 0))                                       
    { usecPerDgram = ((float)TotTT3) / ((float)CombinedTotalDgrams);            
      printf(                                                                   
      "%s                  Combined : %d usec/dgram.\n",                        
              msgp, (int)usecPerDgram);                                         
    }                                                                           
                                                                                
 /*******************************************************                       
  * Capacity Report                                     *                       
  *******************************************************/                      
                                                                                
  if ( (ServerUsefulDgramPerSec > 0) && (fServerTT3 > 0.000001) &&              
       (reliable || (nbufrcvd == MsgBuf.nbufsent)) )                            
    { f1 = (int)(ServerUsefulDgramPerSec / ServerUtil);                         
      f2 = ServerUsefulMBS / ServerUtil;                                        
      f3 = (int)(ServerTotalDgramPerSec / ServerUtil);                          
      f4 = ServerTotalMBS / ServerUtil;                                         
      if (LetsAssumeLoopback)                                                   
        { printf("%s Server Capacity at 100%% of one CPU,",msgp);               
          printf(" and assumes this was loopback:\n");                          
        }                                                                       
        else printf("%s Server Capacity at 100%% of one CPU:\n",msgp);          
      printf("%s              %d datagrams/second/CPU,", msgp, (int)f1);        
      if (reliable)                                                             
        { printf(" %6.3f MBS/CPU. (data xfer only)\n", f2);                     
          printf("%s              %d datagrams/second/CPU,",                    
                     msgp, (int)f3);                                            
          printf("%6.3f MBS/CPU. (data xfer+ACKs)\n", f4);                      
        }                                                                       
        else printf(" %6.3f MBS/CPU.\n", f2);                                   
    }                                                                           
#endif                                                                          
                                                                                
} /* Receive() */                                                               
                                                                                
/*=============================*                                                
 | --RecordMessageHasArrived() |                                                
 *=============================*/                                               
                                                                                
void RecordMessageHasArrived(i)                                                 
int i;                                                                          
{ int ii,j,k,l;                                                                 
                                                                                
  ii = i % MAXwindowSIZE;                                                       
  dgstatus[ii].flags = 0;                                                       
/*                                                                              
  if (dgstatus[ii].flags & dgsRECEIVEDdgram)                                    
    { itsadup = 1;                                                              
      nduprcvd = nduprcvd + 1;                                                  
      msg1(2, "Received dgram %d is a duplicate.", i);                          
      if (monitor_the_monitor) printf("!");                                     
    }                                                                           
    else                                                                        
*/                                                                              
    { dgstatus[ii].flags = dgstatus[i].flags | dgsRECEIVEDdgram;                
      dgstatus[ii].dgram_num = i;                                               
    }                                                                           
                                                                                
  if (MsgBuf.flags & REQUESTack)                                                
     dgstatus[ii].flags = dgstatus[ii].flags | dgsREQUESTEDack;                 
  if (MsgBuf.flags & MUSTack)                                                   
     dgstatus[ii].flags = dgstatus[ii].flags | dgsMUSTack;                      
  if (MsgBuf.flags & REQUESTstatistics)                                         
     dgstatus[ii].flags = dgstatus[ii].flags | dgsREQUESTEDstats;               
                                                                                
  j = -1; l = suna + 1; ii = l % MAXwindowSIZE;                                 
  if (i < l)                                                                    
     j = i;                                                                     
     else                                                                       
     for (k=l; k<l+window; k=k+1)                                               
        { if (!(dgstatus[ii].flags & dgsRECEIVEDdgram))                         
             break;                                                             
          if (dgstatus[ii].dgram_num < i)                                       
             break;                                                             
          suna = k;                                                             
          if (dgstatus[ii].flags & dgsREQUESTEDack)                             
             j = k;                                                             
          if (dgstatus[ii].flags & dgsMUSTack)                                  
             break;                                                             
          ii = (ii+1) % MAXwindowSIZE;                                          
        }                                                                       
                                                                                
  if (j != -1)                                                                  
    { AckToSend = j;          /* need to send an ack back */                    
      StartTimeStashs[j % MAXwindowSIZE] = MsgBuf.start_time;                   
      msg2(3,"RecordMessageHasArrived, dgram#=%d, AckToSend=%d.",               
            i, AckToSend);                                                      
      if (MsgBuf.flags & LASTdgram)                                             
         ThisIsLastDgram = 1;                                                   
    }                                                                           
    else msg1(3, "RecordMessageHasArrived, dgram#=%d.", i);                     
}  /* RecordMessageHasArrived() */                                              
                                                                                
/*=====================*                                                        
 | --ResendLastBurst() |                                                        
 *=====================*/                                                       
                                                                                
void ResendLastBurst()                                                          
{ int i,ii,j, retcode;                                                          
  AccumTimeouts = AccumTimeouts + 1;                                            
  if (monitor_the_monitor)                                                      
     printf("x%d:",suna);                                                       
     else printf("%s Resending last burst, suna=%d.\n", msgp, suna);            
  if (MustReturnAllAcks)                                                        
     j = suna+prevwindow;                                                       
     else j = suna+window;                                                      
  ii = suna % MAXwindowSIZE;                                                    
  for (i=suna; i<j; i=i+1)                                                      
     { if ( (dgstatus[ii].flags & dgsSENTone) &&                                
               !(dgstatus[ii].flags & dgsRECEIVEDackBACK))                      
         { if ((!monitor_the_monitor) && (!Silent))                             
              printf("%s Resending dgram %d.\n",msgp,i);                        
           retcode = SendDgram(i);                                              
           nbufrsnt = nbufrsnt + 1;                                             
           nbytrsnt = nbytrsnt + retcode;                                       
           if (!MustReturnAllAcks)                                              
              if (dgstatus[ii].flags & dgsREQUESTEDack)                         
                { if (!Silent)                                                  
                    { printf("%s RequestedAck flag on this dgram,",             
                              msgp);                                            
                      printf(" end of burst at %d.\n", i);                      
                    }                                                           
                  break;                                                        
                }                                                               
         }                                                                      
       ii = (ii+1) % MAXwindowSIZE;                                             
     }                                                                          
}  /* ResendLastBurst() */                                                      
                                                                                
/*==============*                                                               
 | --resetdgs() |                                                               
 *==============*/                                                              
                                                                                
void resetdgs()                                                                 
{ int i;                                                                        
  for (i=0; i<MAXwindowSIZE; i=i+1)                                             
     { dgstatus[i].flags = 0;                                                   
       dgstatus[i].dgram_num = -1;                                              
     }                                                                          
} /* resetdgs() */                                                              
                                                                                
/*=================*                                                            
 | --ResetServer() |                                                            
 *=================*/                                                           
                                                                                
#if defined(MVS)                                                                
void ResetServer(NewQueueing)                                                   
int NewQueueing;                                                                
#else                                                                           
void ResetServer()                                                              
#endif                                                                          
{ resetdgs();                                                                   
  AccumBytesReceived = AccumBytesSent =                                         
    AccumDgramsReceived = AccumDgramsSent =                                     
    AccumBlockingReceives = AccumNonBlockingReceives = 0;                       
  nbufrcvd = nbytrcvd = nduprcvd = 0;                                           
  nbufsent = nbytsent = 0;                                                      
  suna = -1;                                                                    
                                                                                
#if defined(MVS)                                                                
  ResetServerBulkmode(NewQueueing);                                             
#endif                                                                          
                                                                                
  GetServerStartTime();                                                         
} /* ResetServer() */                                                           
                                                                                
/*=========================*                                                    
 | --ResetServerBulkmode() |                                                    
 *=========================*/                                                   
                                                                                
#if defined(MVS)                                                                
void ResetServerBulkmode(NewQueueing)                                           
int NewQueueing;                                                                
{ if (bulkmode)                                                                 
     KickSocketIntoBulkmode(NewQueueing, recvqlen, sendqlen,                    
                       movedata, etststor, NewQueueing);                        
                                                                                
} /* ResetServerBulkmode() */                                                   
#endif                                                                          
                                                                                
/*=================*                                                            
 | --ResetClient() |                                                            
 *=================*/                                                           
                                                                                
void ResetClient()                                                              
{ resetdgs();                                                                   
  TotTAT = 0;                                                                   
  ntimeout = nbufsent = nbytsent = nbufrsnt = nbytrsnt = nduprcvd = 0;          
  nIUCVsent = nIUCVrcvd = AccumTimeouts = 0;                                    
  firstend = 1; suna = snext = 0;                                               
} /* ResetClient() */                                                           
                                                                                
/*==========================*                                                   
 | --SeeIfAnyAcksAreThere() |                                                   
 *==========================*/                                                  
                                                                                
void SeeIfAnyAcksAreThere(WereNoAcks)                                           
int *WereNoAcks;                                                                
{ int retcode; int DontCare;                                                    
  retcode = TryANonBlockingRecv(&DontCare); /*(4)*/                             
  *WereNoAcks = (retcode < 0); /* Note: errno other than EWOULDBLOCK is */      
                               /* checked for in TryANonBlockingRecv.   */      
} /* SeeIfAnyAcksAreThere() */                                                  
                                                                                
/*============================*                                                 
 | --SendAllThatArePossible() |                                                 
 *============================*/                                                
                                                                                
void SendAllThatArePossible(AllAreSent)                                         
int *AllAreSent;                                                                
{ int retcode;                                                                  
  while (snext < (suna+window))                                                 
    { if (snext == (orignbuf + nlastbuf))                                       
        { *AllAreSent = 1;                                                      
          return;                                                               
        }                                                                       
      if (pacing)                                                               
        { msg1(-3, "About to sleep %d msecs.", pacing);                         
          msdelay(pacing);                                                      
        }                                                                       
      retcode = SendDgram(snext);                                               
      nbytsent = nbytsent + retcode;                                            
      nbufsent = nbufsent + 1;                                                  
      snext = snext + 1;                                                        
      msg2(3, "So far, %d messages sent, %d bytes sent.",                       
            nbufsent, nbytsent);                                                
    }                                                                           
  if (MustReturnAllAcks)                                                        
    { prevwindow = window;                                                      
      nextburst = 0;                                                            
    }                                                                           
} /* SendAllThatArePossible() */                                                
                                                                                
/*=====================*                                                        
 | --SendAnyAcksBack() |                                                        
 *=====================*/                                                       
                                                                                
void SendAnyAcksBack()                                                          
{ char buf20[21];                                                               
  int  i, retcode, TimedOut, use_len;                                           
  if (AckToSend == -1)       /* don't need to send an ack back */               
    { msg(-3, "", "SendAnyAcksBack(): No AckToSend.");                          
      return;                                                                   
    }                                                                           
  msg1(-3, "SendAnyAcksBack(): AckToSend=%d.", AckToSend);                      
  i = nxtackbf;                                                                 
  use_len = acklen;                                                             
  if (monitor_the_monitor)                                                      
     printf("a%d:%d",i,AckToSend);                                              
  AckBufs[i].dgram_num = AckToSend;                                             
  AckBufs[i].start_time = StartTimeStashs[AckToSend % MAXwindowSIZE];           
  AckBufs[i].flags = WHATiAM | ACKdgram;                                        
  if (QueueingIsAvailable)                                                      
     AckBufs[i].flags = AckBufs[i].flags | QUEUEINGisAVAILABLE;                 
  if (QueueingIsOn)                                                             
     AckBufs[i].flags = AckBufs[i].flags | QUEUEINGisON;                        
  if (ThisIsLastDgram)                                                          
    { AckBufs[i].flags = AckBufs[i].flags | LASTdgram;                          
      ThisIsLastDgram = 0;                                                      
    }                                                                           
  AckBufs[i].AccumBytesReceived  = AccumBytesReceived;                          
  AckBufs[i].AccumBytesSent      = AccumBytesSent;                              
  AckBufs[i].AccumDgramsReceived = AccumDgramsReceived;                         
  AckBufs[i].AccumDgramsSent     = AccumDgramsSent;                             
  AckBufs[i].AccumNonBlockingReceives = AccumNonBlockingReceives;               
  AckBufs[i].AccumBlockingReceives = AccumBlockingReceives;                     
  if (RequestStatisticsOnNextDgram || RequestNetstatOnNextDgram)                
    {                                                                           
#if defined(MVS)                                                                
      if (montcpip)                                                             
        { if (RequestStatisticsOnNextDgram)                                     
            {                                                                   
              ReadMibRecord(&MibResponse, &MibResponseLength);                  
              memcpy(&AckBufs[i].MibResponse, &MibResponse,                     
                                       MibResponseLength);                      
            }                                                                   
/*                                                                              
          if (RequestNetstatOnNextDgram)                                        
            { int len;                                                          
printf("calling ReadNetstatResponse\n");                                        
NetstatResponseLength = 8000;                                                   
              ReadNetstatRecord("UP",NetstatResponse, &NetstatResponseLength);  
printf("Netstat len=%d response=\n",NetstatResponseLength);                     
printf("%s\n",NetstatResponse);                                                 
              if (NetstatResponseLength > 0)                                    
                 memcpy(&AckBufs[i].data_part, &NetstatResponse,                
                                       NetstatResponseLength);                  
            }                                                                   
*/                                                                              
        }                                                                       
      if (bulkmode && QueueingIsOn)                                             
        { Readgetibmsockopt();                                                  
          AckBufs[i].AccumIUCVReceiveMessages =                                 
                           bulkstr.b_num_IUCVs_received;                        
          AckBufs[i].AccumIUCVSendMessages =                                    
                           bulkstr.b_num_IUCVs_sent;                            
        }                                                                       
        else                                                                    
        { AckBufs[i].AccumIUCVReceiveMessages = nbufrcvd;                       
          AckBufs[i].AccumIUCVSendMessages = nbufsent;                          
        }                                                                       
#endif                                                                          
      AckBufs[i].AccumDaemonCpuTaskTime = clock() *                             
                      (1000000 / CLOCKS_PER_SEC);                               
      use_len = 0;                                                              
      if (RequestStatisticsOnNextDgram)                                         
        { AckBufs[i].flags = AckBufs[i].flags | STATISTICSfieldsVALID;          
          RequestStatisticsOnNextDgram = FALSE;                                 
          use_len = max(MINackLENGTH, STATISTICSfieldsVALIDsize);               
        }                                                                       
      if (RequestStatisticsOnNextDgram)                                         
        { if (NetstatResponseLength > 0)                                        
            { AckBufs[i].flags = AckBufs[i].flags | REQUESTnetstat;             
              use_len = max(use_len,                                            
                        STATISTICSfieldsVALIDsize + NetstatResponseLength);     
            }                                                                   
          RequestNetstatOnNextDgram    = FALSE;                                 
        }                                                                       
      use_len = max(acklen, use_len);                                           
    }                                                                           
                                                                                
#if defined(USEtcpip)                                                           
  retcode = sendto(s, (char *)&AckBufs[i], use_len, 0,                          
                   (struct sockaddr *)&rsock, rsocklen);                        
  if (debug >= 2)                                                               
    { ConvertToDottedDecimal(rsock.sin_addr.s_addr, buf20);                     
      printf("%s Sent dgram number %d to %s/%d, len=%d, flags=%8X=\n",          
              msgp, AckBufs[i].dgram_num, buf20,                                
              rsock.sin_port, retcode, AckBufs[i].flags);                       
      printf("%s     ", msgp);                                                  
      SnapFlags(AckBufs[i].flags);                                              
      if (debug >= 4)                                                           
         PrintDgram(&AckBufs[i]);                                               
    }                                                                           
#else                                                                           
  retcode = 0;                                                                  
#endif                                                                          
                                                                                
  if (retcode < 0)                                                              
#if defined(OS2)                                                                
    { oops("on sendto()"); }                                                    
#else                                                                           
     if (errno == EWOULDBLOCK)                                                  
       { DoSelectOnWriteSocket(TimeoutForSelect, &TimedOut);                    
         if (TimedOut)                                                          
           { oops("TimedOut on select() following sendto()");                   
           }                                                                    
         msg(3, "ssa",                                                          
              "About to sendto(ACK) after select() after sendto(<--).");        
         retcode = sendto(s, (char *)p_dgram, use_len, 0,                       
                          (struct sockaddr *)&rsock,sizeof(rsock));             
         if (retcode < 0)                                                       
            oops("on sendto() following the select() after sendto()");          
       }                                                                        
     else oops("on sendto()");                                                  
#endif                                                                          
                                                                                
  if (receiver)                                                                 
    { AccumBytesSent  = AccumBytesSent + retcode;                               
      AccumDgramsSent = AccumDgramsSent + 1;                                    
    }                                                                           
  if (monitor_the_monitor) printf(".");                                         
  if (retcode < 0)                                                              
     oops("on sendto(ACK)");                                                    
  nxtackbf = (nxtackbf + 1) % MAXwindowSIZE;                                    
  AckToSend = -1;                                                               
  nbufsent = nbufsent + 1;                                                      
  nbytsent = nbytsent + retcode;                                                
  if (bulkmode)                                                                 
     FlushOutboundQueue();                                                      
}  /* SendAnyAcksBack() */                                                      
                                                                                
/*=============*                                                                
 | --SendDgram |                                                                
 *=============*/                                                               
                                                                                
int SendDgram(n)                                                                
int n;                                                                          
{ char buf20[21];                                                               
  int  ii, retcode, use_len, TimedOut;                                          
  use_len = smsglen;                                                            
  ii = n % MAXwindowSIZE;                                                       
  if (n >= orignbuf)                                                            
     if (firstend)                                                              
       { ClientEndTime = GetWallClockTimeInMicroseconds();                      
         ClientElapsedTime = (int)(ClientEndTime - ClientStartTime);            
         fClientElapsedTime = (float)ClientElapsedTime;                         
         buflast.elapsed_time = ClientElapsedTime;                              
         f1 = (double)clock();                                                  
         SendTT2 = (f1 * 1000000.0 / CLOCKS_PER_SEC);                           
         SendTT3 = (int)(SendTT2 - SendTT1);                                    
         /* We are going to assume that on both sides:                          
            sizeof(int)==4 and they have the same storage format.               
         */                                                                     
         buflast.flags = LASTdgram | REQUESTack;                                
         dgstatus[ii].flags = dgstatus[ii].flags | dgsLASTdgram                 
                                                     | dgsREQUESTEDack;         
         if (!somexdisplay)                                                     
            buflast.flags = buflast.flags | SHUTDOWNonLASTdgram;                
         buflast.nbufsent = nbufsent;                                           
         buflast.nbytsent = nbytsent;                                           
         buflast.nbufrcvd = nbufrcvd;                                           
         buflast.nbytrcvd = nbytrcvd;                                           
         buflast.cpu_time = SendTT3;                                            
                                                                                
#if defined(MVS)                                                                
         if (bulkmode)                                                          
           { int optlen;                                                        
             optlen = sizeof(bulkstr);                                          
             retcode = getibmsockopt(s, SOL_SOCKET, SO_BULKMODE,                
                                     (unsigned char *) &bulkstr, &optlen);      
             nIUCVsent = bulkstr.b_num_IUCVs_sent + 1;                          
           }                                                                    
           else nIUCVsent = nbufsent;                                           
#endif                                                                          
                                                                                
         buflast.nIUCVsent = nIUCVsent;                                         
         buflast.nIUCVrcvd = nIUCVrcvd;                                         
         if (reliable || montcpip)                                              
           { buflast.ntimeout = ntimeout;                                       
             buflast.nbufrsnt = nbufrsnt;                                       
             buflast.nbytrsnt = nbytrsnt;                                       
             buflast.nduprcvd = nduprcvd;                                       
             if (nbufrcvd)                                                      
                buflast.ave_turnaround_time = (int)(TotTAT / nbufrcvd);         
                else buflast.ave_turnaround_time = -1;                          
           }                                                                    
         p_dgram = &buflast;                                                    
         firstend = 0;                                                          
         (*p_dgram).dgram_length = -1;                                          
       }                                                                        
       else { }                                                                 
     else { p_dgram = &MsgBufs[n % MAXwindowSIZE];                              
            (*p_dgram).flags = 0;                                               
            if ( (!burstsiz) ||                                                 
                 (((n+1) % burstsiz) == 0) ||                                   
                 (n == (orignbuf-1)) )                                          
               dgstatus[ii].flags = dgstatus[n].flags | dgsREQUESTEDack;        
          }                                                                     
  if (dgstatus[ii].flags & dgsREQUESTEDack)                                     
     (*p_dgram).flags = (*p_dgram).flags | REQUESTack;                          
  if (dgstatus[ii].flags & dgsMUSTack)                                          
     (*p_dgram).flags = (*p_dgram).flags | MUSTack;                             
  if (dgstatus[ii].flags & dgsREQUESTEDstats)                                   
     (*p_dgram).flags = (*p_dgram).flags | REQUESTstatistics;                   
  if (dgstatus[ii].flags & dgsLASTdgram)                                        
    { (*p_dgram).flags = (*p_dgram).flags | dgsLASTdgram;                       
      (*p_dgram).dgram_length = -1;                                             
    }                                                                           
                                                                                
  (*p_dgram).dgram_num = n;                                                     
  (*p_dgram).flags = (*p_dgram).flags | WHATiAM;                                
  if (n == 0)                                                                   
    { (*p_dgram).flags = (*p_dgram).flags | RESETserver;                        
      if (somexdisplay)                                                         
        { (*p_dgram).flags = (*p_dgram).flags | USINGxDISPLAY;                  
        }                                                                       
      (*p_dgram).NewRecvQSize = NewRecvQSize;                                   
      (*p_dgram).NewSendQSize = NewSendQSize;                                   
      (*p_dgram).NewAckLen = NewAckLen;                                         
      use_len = max(use_len, RESETserverSIZE);                                  
    }                                                                           
  if (ChangeAckLenOnNextDgram)                                                  
    { (*p_dgram).flags = (*p_dgram).flags | CHANGEackLEN;                       
      (*p_dgram).NewAckLen = NewAckLen;                                         
      ChangeAckLenOnNextDgram = FALSE;                                          
      use_len = max(use_len, RESETserverSIZE);                                  
    }                                                                           
  if (ChangePacingOnNextDgram)                                                  
    { (*p_dgram).flags = (*p_dgram).flags | CHANGEpacing;                       
      (*p_dgram).NewPacing = NewPacing;                                         
      ChangePacingOnNextDgram = FALSE;                                          
      use_len = max(use_len, RESETserverSIZE);                                  
    }                                                                           
  if (ChangeQueueingOnNextDgram)                                                
    { (*p_dgram).flags = (*p_dgram).flags | CHANGEqueueing;                     
      (*p_dgram).NewRecvQSize = NewRecvQSize;                                   
      (*p_dgram).NewSendQSize = NewSendQSize;                                   
      ChangeQueueingOnNextDgram = FALSE;                                        
      use_len = max(use_len, RESETserverSIZE);                                  
    }                                                                           
  if (RequestNetstatOnNextDgram)                                                
    { (*p_dgram).flags = (*p_dgram).flags | REQUESTnetstat;                     
      RequestNetstatOnNextDgram = FALSE;                                        
    }                                                                           
  if (RequestStatisticsOnNextDgram)                                             
    { (*p_dgram).flags = (*p_dgram).flags | REQUESTstatistics;                  
      RequestStatisticsOnNextDgram = FALSE;                                     
    }                                                                           
  if (ToggleQueueingOnNextDgram)                                                
    { (*p_dgram).flags = (*p_dgram).flags | TOGGLEqueueing;                     
      (*p_dgram).NewRecvQSize = NewRecvQSize;                                   
      (*p_dgram).NewSendQSize = NewSendQSize;                                   
      ToggleQueueingOnNextDgram = FALSE;                                        
      use_len = max(use_len, RESETserverSIZE);                                  
    }                                                                           
                                                                                
  if (debug >= 4)                                                               
     PrintDgram(p_dgram);                                                       
     else if (monitor_the_monitor) printf("s%d",n);                             
                                                                                
  if (n < orignbuf)                                                             
     (*p_dgram).dgram_length = use_len;                                         
                                                                                
  if (reliable || montcpip)                                                     
     if (receiver)                                                              
        (*p_dgram).start_time = StartTimeStashs[n & MAXwindowSIZE];             
        else    /* Following is used to calculate TurnaroundTime in monitor */  
        if (AccumStartTimeStash < 0)                                            
           AccumStartTimeStash = (*p_dgram).start_time =                        
             GetWallClockTimeInMicroseconds();                                  
                                                                                
  StartTimeStash = GetWallClockTimeInMicroseconds();                            
                                                                                
#if defined(USEtcpip)                                                           
  retcode = sendto(s, (char *)p_dgram, use_len, 0,                              
                   (struct sockaddr *)&rsock, sizeof(rsock));                   
  if (debug >= 2)                                                               
    { ConvertToDottedDecimal(rsock.sin_addr.s_addr, buf20);                     
      printf("%s Sent dgram number %d to %s/%d, len=%d, flags=%8X=\n",          
                msgp, (*p_dgram).dgram_num, buf20,                              
                rsock.sin_port, retcode, (*p_dgram).flags);                     
      printf("%s     ", msgp);                                                  
      SnapFlags((*p_dgram).flags);                                              
      if (debug >= 4)                                                           
         PrintDgram(p_dgram);                                                   
    }                                                                           
                                                                                
#else                                                                           
  retcode = 0;                                                                  
#endif                                                                          
                                                                                
  if (retcode < 0)                                                              
#if defined(OS2)                                                                
    { oops("on sendto()"); }                                                    
#else                                                                           
     if (errno == EWOULDBLOCK)                                                  
       { DoSelectOnWriteSocket(TimeoutForSelect, &TimedOut);                    
         if (TimedOut)                                                          
           { oops("TimedOut on select() following sendto()");                   
           }                                                                    
         msg(3, "ssd",                                                          
            "About to sendto(DATA) after select() after sendto(<---).");        
#if defined(USEtcpip)                                                           
         retcode = sendto(s, (char *)p_dgram, use_len, 0,                       
                          (struct sockaddr *)&rsock,sizeof(rsock));             
#else                                                                           
         retcode = 0;                                                           
#endif                                                                          
         if (retcode < 0)                                                       
            oops("on sendto() following the select() after sendto()");          
       }                                                                        
     else oops("on sendto()");                                                  
#endif                                                                          
                                                                                
  if (monitor_the_monitor)                                                      
     if (p_dgram == &buflast)                                                   
        printf("e.");                                                           
        else printf(".");                                                       
                                                                                
  if (retcode < 0)                                                              
     oops("on sendto()");                                                       
                                                                                
  if (reliable)                                                                 
     dgstatus[ii].flags = dgstatus[n].flags | dgsSENTone;                       
                                                                                
  if (retcode != use_len)                                                       
    { printf("%s oops, rc=%d, but smsglen=%d.\n",                               
              msgp, retcode, smsglen);                                          
      return(-1);                                                               
    }                                                                           
  return(retcode);                                                              
}  /* SendDgram() */                                                            
                                                                                
/*============================*                                                 
 | --SetSocketToNonBlocking() |                                                 
 *============================*/                                                
                                                                                
void SetSocketToNonBlocking()                                                   
{ msg(-3, "-.", "About to ioctl(FIONBIO).");                                    
#if defined(OS2)                                                                
#if defined(USEtcpip)                                                           
  ioctl(s, FIONBIO, (char *) &one, 0);                                          
#endif                                                                          
#else                                                                           
#if defined(USEtcpip)                                                           
  if (ioctl(s, FIONBIO, (char *) &one) < 0)                                     
     oops("on ioctl()");                                                        
#endif                                                                          
#endif                                                                          
  msg(3, "", "Back from ioctl(FIONBIO).");                                      
}  /* SetSocketToNonBlocking() */                                               
                                                                                
/*=================*                                                            
 | --SnapBulkstr() |                                                            
 *=================*/                                                           
                                                                                
void SnapBulkstr()                                                              
{                                                                               
#if defined(MVS)                                                                
  if (bulkmode)                                                                 
    { printf("%s About to setibmsockopt(",msgp);                                
      if (bulkstr.b_onoff)                                                      
         printf("ON,");                                                         
         else printf("OFF,");                                                   
      printf("%d,%d,",                                                          
              bulkstr.b_max_receive_queue_size,                                 
              bulkstr.b_max_send_queue_size);                                   
      if (bulkstr.b_move_data)                                                  
         printf("MOVEDATA ON,");                                                
         else printf("MOVEDATA OFF,");                                          
      if (bulkstr.b_teststor)                                                   
         printf("TESTSTORE ON).\n");                                            
         else printf("TESTSTORE OFF).\n");                                      
    }                                                                           
#endif                                                                          
}  /* SnapBulkstr() */                                                          
                                                                                
/*===============*                                                              
 | --SnapFlags() |                                                              
 *===============*/                                                             
                                                                                
void SnapFlags(i)                                                               
int i;                                                                          
{ char draw_bar[2];                                                             
  strcpy(draw_bar, "");                                                         
  printf("(");                                                                  
  if (i & FROMmvs)                                                              
    { printf("%sFROMmvs",draw_bar);              strcpy(draw_bar," "); }        
  if (i & FROMunixHOST)                                                         
    { printf("%sFROMunixHOST",draw_bar);         strcpy(draw_bar," "); }        
  if (i & USINGxDISPLAY)                                                        
    { printf("%sUSINGxDISPLAY",draw_bar);        strcpy(draw_bar," "); }        
  if (i & ACKdgram)                                                             
    { printf("%sACKdgram",draw_bar);             strcpy(draw_bar," "); }        
  if (i & STATISTICSfieldsVALID)                                                
    { printf("%sSTATISTICSfieldsVALID",draw_bar);strcpy(draw_bar," "); }        
  if (i & QUEUEINGisAVAILABLE)                                                  
    { printf("%sQUEUEINGisAVAILABLE",draw_bar);  strcpy(draw_bar," "); }        
  if (i & QUEUEINGisON)                                                         
    { printf("%sQUEUEINGisON",draw_bar);         strcpy(draw_bar," "); }        
  if (i & RESETserver)                                                          
    { printf("%sRESETserver",draw_bar);          strcpy(draw_bar," "); }        
  if (i & CHANGEackLEN)                                                         
    { printf("%sCHANGEackLEN",draw_bar);         strcpy(draw_bar," "); }        
  if (i & CHANGEpacing)                                                         
    { printf("%sCHANGEpacing",draw_bar);         strcpy(draw_bar," "); }        
  if (i & CHANGEqueueing)                                                       
    { printf("%sCHANGEqueueing",draw_bar);       strcpy(draw_bar," "); }        
  if (i & TOGGLEqueueing)                                                       
    { printf("%sTOGGLEqueueing",draw_bar);       strcpy(draw_bar," "); }        
  if (i & REQUESTstatistics)                                                    
    { printf("%sREQUESTstatistics",draw_bar);    strcpy(draw_bar," "); }        
  if (i & REQUESTnetstat)                                                       
    { printf("%sREQUESTnetstat",draw_bar);       strcpy(draw_bar," "); }        
  if (i & REQUESTack)                                                           
    { printf("%sREQUESTack",draw_bar);           strcpy(draw_bar," "); }        
  if (i & LASTdgram)                                                            
    { printf("%sLASTdgram",draw_bar);            strcpy(draw_bar," "); }        
  if (i & SHUTDOWNonLASTdgram)                                                  
    { printf("%sSHUTDOWNonLASTdgram",draw_bar);  strcpy(draw_bar," "); }        
  printf(").\n");                                                               
}  /* SnapFlags() */                                                            
                                                                                
/*=====================*                                                        
 | --SnapLastMessage() |                                                        
 *=====================*/                                                       
                                                                                
void SnapLastMessage()                                                          
{ printf("%s last packet: number %d, flags=%8X=",                               
          msgp, MsgBuf.dgram_num, MsgBuf.flags);                                
  SnapFlags(MsgBuf.flags);                                                      
  printf("%s              cpu=%d elapsed=%d,\n",                                
          msgp, MsgBuf.cpu_time, MsgBuf.elapsed_time);                          
  printf("%s              nbufsent=%d nbytsent=%d",                             
          msgp, MsgBuf.nbufsent, MsgBuf.nbytsent);                              
  printf(" nbufrcvd=%d nbytrcvd=%d,\n", MsgBuf.nbufrcvd, MsgBuf.nbytrcvd);      
  printf("%s              nduprcvd=%d ntimeout=%d nbufrsnt=%d,\n",              
          msgp, MsgBuf.nduprcvd, MsgBuf.ntimeout, MsgBuf.nbufrsnt);             
  printf("%s              nbytrsnt=%d nIUCVsent=%d nIUCVrcvd=%d.\n",            
          msgp, MsgBuf.nbytrsnt, MsgBuf.nIUCVsent, MsgBuf.nIUCVrcvd);           
}  /* SnapLastMessage() */                                                      
                                                                                
/*===============================*                                              
 | --TFLocalNonBlockingAndRecv() |                                              
 *===============================*/                                             
                                                                                
int TFLocalNonBlockingAndRecv()                                                 
{ char buf20[21];                                                               
  int  retcode;                                                                 
                                                                                
  msg(-3, "", "TFLocalNonBlockingAndRecv():");                                  
                                                                                
  retcode = 0;                                                                  
                                                                                
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *            
   | For MVS bulkmode sockets:                                     |            
   | First, flush the outgoing socket queue.                       |            
   * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */           
                                                                                
#if defined(MVS)                                                                
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *            
   | The socket was set for NON-BLOCKING on the local queue (ie.   |            
   | the one on our side of the IUCV interface).                   |            
   | Now set it up so that the recvfrom() will look on the TCPIP   |            
   | side of the IUCV interface for any queued messages, and       |            
   | blocks until there is at least one has arrived.               |            
   * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */           
                                                                                
  { int lenaddr;                                                                
    if (SocketIsLocalNonBlocking)                                               
      { msg(3, "l|", "About to setibmsockopt(SO_NONBLOCKLOCAL off).");          
        retcode = setibmsockopt(s, SOL_SOCKET, SO_NONBLOCKLOCAL,                
                                (unsigned char *) &zero, sizeof(int));          
        msg(3, "", "Back from setibmsockopt(SO_NONBLOCKLOCAL off).");           
        if (retcode < 0)                                                        
           oops("on setibmsockopt(SO_NONBLOCKLOCAL off)");                      
        SocketIsLocalNonBlocking = 0;                                           
      }                                                                         
                                                                                
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *          
     | Now issue the recvfrom() that will get the next message from   |         
     | the TCPIP side.  Block until there is (at least) one.          |         
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */         
                                                                                
    msg(3, "b", "About to call blocking recvfrom().");                          
    lenaddr = sizeof(struct sockaddr);                                          
#if defined(USEtcpip)                                                           
    retcode = recvfrom(s, (unsigned char *) &MsgBuf, buflen, 0,                 
                       (struct sockaddr *)&rsock, (size_rcv)&lenaddr);          
#else                                                                           
    retcode = 0;                                                                
#endif                                                                          
    if (debug >= 2)                                                             
       if (retcode < 0)                                                         
         { printf("%s Blocking recvfrom() returns with rc=%d, ",                
                  msgp, retcode);                                               
#if !defined(OS2)                                                               
           if (errno == EWOULDBLOCK)                                            
              printf("errno = EWOULDBLOCK.\n");                                 
              else printf("errno = %d.\n", errno);                              
#endif /* !OS2 */                                                               
         }                                                                      
         else                                                                   
         { ConvertToDottedDecimal(rsock.sin_addr.s_addr, buf20);                
           printf(                                                              
             "%s Rcvd1 dgram number %d from %s/%d, len=%d, flags=%8X=\n",       
                  msgp, MsgBuf.dgram_num, buf20,                                
                  rsock.sin_port, retcode, MsgBuf.flags);                       
           printf("%s     ", msgp);                                             
           SnapFlags(MsgBuf.flags);                                             
           if (debug >= 4)                                                      
              PrintDgram(&MsgBuf);                                              
         }                                                                      
    if (retcode < 0)                                                            
      { oops("on the blocking recvfrom()"); }                                   
      else { nbufrcvd = nbufrcvd + 1;                                           
             nbytrcvd = nbytrcvd + retcode;                                     
           }                                                                    
    if (receiver)                                                               
      { AccumBlockingReceives = AccumBlockingReceives + 1;                      
        AccumBytesReceived  = AccumBytesReceived + retcode;                     
        AccumDgramsReceived = AccumDgramsReceived + 1;                          
      }                                                                         
  }                                                                             
                                                                                
#else                                                                           
  printf("%s **** oops, EWOULDBLOCK returned ", msgp);                          
  printf("on recvfrom()\n");                                                    
  printf("%s **** this should not happen when", msgp);                          
  printf(" running on a workstation.\n");                                       
  exit(-1);                                                                     
#endif                                                                          
                                                                                
  return(retcode);                                                              
}  /* TFLocalNonBlockingAndRecv() */                                            
                                                                                
/*==================================*                                           
 | --TNLocalNonBlockingAndTryRecv() |                                           
 *==================================*/                                          
                                                                                
int TNLocalNonBlockingAndTryRecv()                                              
{ char buf20[21];                                                               
  int  retcode;                                                                 
                                                                                
  msg(-3, "", "TNLocalNonBlockingAndTryRecv():");                               
                                                                                
  retcode = 0;                                                                  
                                                                                
#if defined(MVS)                                                                
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *            
   | For MVS bulkmode sockets:                                     |            
   | Put the bulkmode socket into non-blocking mode on the local   |            
   | queue.  ie. the following recvfrom() will return with         |            
   | return code == -1 and errno == EWOULDBLOCK if the local queue |            
   | is empty.                                                     |            
   * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */           
                                                                                
  { int lenaddr, retcode;                                                       
    if (!SocketIsLocalNonBlocking)                                              
      { msg(3, "l-", "About to setibmsockopt(SO_NONBLOCKLOCAL on).");           
        retcode = setibmsockopt(s, SOL_SOCKET, SO_NONBLOCKLOCAL,                
                                (unsigned char *) &one, sizeof(int));           
        msg(3, "", "Back from setibmsockopt(SO_NONBLOCKLOCAL on).");            
        if (retcode < 0)                                                        
           oops("on setibmsockopt(SO_NONBLOCKLOCAL on)");                       
        SocketIsLocalNonBlocking = 1;                                           
      }                                                                         
                                                                                
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *          
     | Now issue the recvfrom() that will get the next message from   |         
     | the local queue, if there are any.                             |         
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */         
                                                                                
    lenaddr = sizeof(struct sockaddr);                                          
                                                                                
    msg(3, "n", "About to call (local) non-blocking recvfrom().");              
#if defined(USEtcpip)                                                           
    retcode = recvfrom(s, (unsigned char *) &MsgBuf, buflen, 0,                 
                       (struct sockaddr *)&rsock, (size_rcv)&lenaddr);          
#else                                                                           
    retcode = 0;                                                                
#endif                                                                          
                                                                                
    if (debug >= 2)                                                             
      { if (retcode < 0)                                                        
          { if (debug >= 3)                                                     
              { printf("%s Non-blocking recvfrom() returns with retcode=%d, ",  
                       msgp, retcode);                                          
#if !defined(OS2)                                                               
                if (errno == EWOULDBLOCK)                                       
                   printf("errno = EWOULDBLOCK.\n");                            
                   else printf("errno = %d.\n", errno);                         
#endif                                                                          
              }                                                                 
          }                                                                     
          else                                                                  
          { ConvertToDottedDecimal(rsock.sin_addr.s_addr, buf20);               
            printf(                                                             
             "%s Rcvd2 dgram number %d from %s/%d, len=%d, flags=%8X=\n",       
                   msgp, MsgBuf.dgram_num, buf20,                               
                   rsock.sin_port, retcode, MsgBuf.flags);                      
            printf("%s     ", msgp);                                            
            SnapFlags(MsgBuf.flags);                                            
            if (debug >= 4)                                                     
               PrintDgram(&MsgBuf);                                             
          }                                                                     
      }                                                                         
#if !defined(OS2)                                                               
      else if (errno == EWOULDBLOCK)                                            
              msg(2, ".", "Returns w/ errno == EWOULDBLOCK.");                  
#endif                                                                          
    if (receiver)                                                               
       if (retcode >= 0)                                                        
         { AccumNonBlockingReceives = AccumNonBlockingReceives + 1;             
           AccumBytesReceived  = AccumBytesReceived + retcode;                  
           AccumDgramsReceived = AccumDgramsReceived + 1;                       
         }                                                                      
    if (retcode >= 0)                                                           
      { nbufrcvd = nbufrcvd + 1;                                                
        nbytrcvd = nbytrcvd + retcode;                                          
      }                                                                         
  }                                                                             
#endif                                                                          
                                                                                
  return(retcode);                                                              
}  /* TNLocalNonBlockingAndTryRecv() */                                         
                                                                                
/*====================*                                                         
 | --ToggleQueueing() |                                                         
 *====================*/                                                        
                                                                                
void ToggleQueueing()                                                           
{ ToggleQueueingOnNextDgram = TRUE;                                             
} /* ToggleQueueing() */                                                        
                                                                                
/*==============*                                                               
 | --Transmit() |                                                               
 *==============*/                                                              
                                                                                
void Transmit()                                                                 
{ int AckIsADuplicate;                                                          
  int AllAreBack;                                                               
  int AllAreSent = 0;                                                           
  int DgramNum;                                                                 
  int retcode;                                                                  
  int TimedOut;                                                                 
  int WereNoAcksThere;                                                          
  int WindowHasMoved;                                                           
                                                                                
  msg4(-3,                                                                      
        "Transmit(): orignbuf=%d, smsglen=%d, bulkmode=%d, reliable=%d.",       
            orignbuf, smsglen, bulkmode, reliable);                             
                                                                                
#if defined(MVS)                                                                
  if (bulkmode)                                                                 
     if (reliable)                                                              
        KickSocketIntoBulkmode(bulkmode, DEFAULTrecvQSIZE, sendqlen,            
                               movedata, etststor, 0);                          
        else                                                                    
        KickSocketIntoBulkmode(bulkmode,0,sendqlen,movedata,etststor,0);        
#endif                                                                          
                                                                                
  ResetClient();                                                                
  AllAreBack = !(reliable || montcpip);                                         
                                                                                
  GetClientStartTime();                                                         
  do { if (!AllAreSent)                                                         
          SendAllThatArePossible(&AllAreSent);                                  
                                                                                
       if (reliable || montcpip)                                                
          do { SeeIfAnyAcksAreThere(&WereNoAcksThere);                          
                                                                                
               if (bulkmode && reliable && WereNoAcksThere)                     
                  FlushOutboundQueue();                                         
                                                                                
               if (WereNoAcksThere)                                             
                  do { if (somexdisplay)                                        
                          MyXDispatcher();                                      
                       DoPollingSelect(rseltime, &TimedOut);                    
                       if (TimedOut)                                            
                          ResendLastBurst();                                    
                          else { retcode = TryABlockingRecv(); /*(3)*/          
                                 if (retcode < 0)                               
                                    exit(-1);                                   
                               }                                                
                     } while(TimedOut);                                         
                                                                                
               HandleTheAck(&AckIsADuplicate, &DgramNum, &AllAreBack);          
               if (!AckIsADuplicate)                                            
                 { MoveTheWindow(DgramNum, &WindowHasMoved,                     
                                                  &AllAreBack);                 
                   if (suna >= orignbuf)                                        
                      break;                                                    
                 }                                                              
                 else { nduprcvd = nduprcvd + 1;                                
                        if (monitor_the_monitor) printf("!");                   
                      }                                                         
             } while((!AllAreSent) && (!WindowHasMoved) &&                      
                     (!AllAreBack));                                            
                                                                                
       if (bulkmode && flushat)                                                 
          if ((nbufsent % flushat) == 0)                                        
             FlushOutboundQueue();                                              
                                                                                
       if (somexdisplay)                                                        
          MyXDispatcher();                                                      
                                                                                
       if (ResetServerOnNextDgram)                                              
         { ResetClient();                                                       
           ResetServerOnNextDgram = FALSE;                                      
         }                                                                      
                                                                                
     } while(!AllAreBack);                                                      
                                                                                
  if (bulkmode)                                                                 
     if (!flushat)                                                              
        FlushOutboundQueue();                                                   
        else if ((nbufsent % flushat) != 0)                                     
                FlushOutboundQueue();                                           
                                                                                
  if (monitor_the_monitor) printf("\n");                                        
                                                                                
  if (ClientElapsedTime > 0)                                                    
     ClientUsefulMBS = ((double)nbytsent) /                                     
                                    ((double)ClientElapsedTime);                
     else ClientUsefulMBS = -1;                                                 
                                                                                
  printf("%s Done. %d datagrams sent", msgp, nbufsent);                         
  if (reliable)                                                                 
     printf(", %d timeouts, %d resent", ntimeout, nbufrsnt);                    
  printf(", %d bytes sent.\n", nbytsent);                                       
  if (reliable)                                                                 
     printf("%s       %d datagrams received, %d bytes received.\n",             
            msgp, nbufrcvd, nbytrcvd);                                          
                                                                                
  if (nIUCVsent > 0)                                                            
    { printf("%s         Send: %d IUCVs,", msgp, nIUCVsent);                    
      printf(" %6.0f bytes/IUCV, %6.2f datagrams/IUCV.\n",                      
              ((float)nbytsent) / ((float)nIUCVsent),                           
              ((float)nbufsent) / ((float)nIUCVsent));                          
    }                                                                           
  if (nIUCVrcvd > 0)                                                            
    { printf("%s         Recv: %d IUCVs,", msgp, nIUCVrcvd);                    
      printf(" %6.0f bytes/IUCV, %6.2f datagrams/IUCV.\n",                      
              ((float)nbytrcvd) / ((float)nIUCVrcvd),                           
              ((float)nbufrcvd) / ((float)nIUCVrcvd));                          
    }                                                                           
                                                                                
  if (ClientUsefulMBS >= 0)                                                     
    {                                                                           
#if !defined(MVS)                                                               
      printf("%s CPU Time=%7.3f seconds (according to clock()),\n",             
              msgp, ((float)SendTT3)/1000000.0);                                
#endif                                                                          
      printf("%s Elapsed Time=%8.3f seconds,",                                  
              msgp, fClientElapsedTime/1000000.0);                              
      printf(" Datarate=%7.3f MBS.\n", ClientUsefulMBS);                        
    }                                                                           
   else printf("%s CPU Time=%d usec, Elapsed Time=%8.3f seconds.\n",            
                msgp, SendTT3, fClientElapsedTime/1000000.0);                   
                                                                                
  msg(3, "", "Leaving Transmit().");                                            
} /* Transmit() */                                                              
                                                                                
/*=========================*                                                    
 | --TransmitForXMonitor() |                                                    
 *=========================*/                                                   
                                                                                
void TransmitForXMonitor()                                                      
{ char            buf[30];                                                      
  int             DontCare;                                                     
  int             retcode, TimedOut;                                            
  struct timeval  tp;                                                           
  struct timezone Tpz;                                                          
                                                                                
  msg3(-3,"TransmitForXMonitor(): orignbuf=%d, smsglen=%d, bulkmode=%d,",       
            orignbuf, smsglen, bulkmode);                                       
  msg1( 3,"                       reliable=%d.", reliable);                     
                                                                                
  RequestStatisticsOnNextDgram = TRUE;                                          
  SendDgram(CurrDgramNum);                                                      
  gettimeofday(&SampleTp, &Tpz);     /* We should probably have the host   */   
                                     /* give us a timestamp in the sample. */   
  GetTOD(SampleTp, SECONDS, buf);      strcpy(SampTs1, buf);                    
  GetTOD(SampleTp, MILLISECONDS, buf); strcpy(SampTs2, buf);                    
  if (ShowMillisecondsOnMonitor)                                                
     strcpy(SampTs3, SampTs2);                                                  
     else                                                                       
     { tp.tv_sec = SampleTp.tv_sec;                                             
       tp.tv_usec = SampleTp.tv_usec + AddVariationToSample * 1000;             
       if (tp.tv_usec > 1000000)                                                
         { tp.tv_sec = tp.tv_sec + 1;                                           
           tp.tv_usec = tp.tv_usec - 1000000;                                   
         }                                                                      
       GetTOD(tp, SECONDS, buf); strcpy(SampTs3, buf);                          
     }                                                                          
  CurrentWallClockUSeconds = (((double)SampleTp.tv_sec) * 1000000) +            
                                                   ((double)SampleTp.tv_usec);  
  NewCountsAvailable = TimedOutThisCycle = FALSE;                               
  DoPollingSelect(rseltime, &TimedOut);                                         
                                                                                
  if (TimedOut)                                                                 
    { /* CalculateTurnaroundTime(); */                                          
      nTriesToConnect = nTriesToConnect + 1;                                    
      if (nTriesToConnect == nTriesBeforeStartingToWhine)                       
        { if (debugt) printf("\n");                                             
          printf("On %s having trouble communicating with host (%s).\n",        
                 SampTs1, hostname);                                            
        }                                                                       
      if ( (nTriesToConnect >= nTriesBeforeStartingToWhine) &&                  
           (nTriesToConnect <= MaxTriesBeforeGivingUp) )                        
         printf("%d unsuccessful tries so far. ", nTriesToConnect);             
      if ( (nTriesToConnect >= nTriesBeforeStartingToWhine) &&                  
           (nTriesToConnect < MaxTriesBeforeGivingUp) )                         
        { printf("We will try %d times before giving up",                       
                 MaxTriesBeforeGivingUp);                                       
          if (debugt)                                                           
             printf(", ");                                                      
             else printf(".\n");                                                
        }                                                                       
      if (nTriesToConnect == MaxTriesBeforeGivingUp)                            
        { printf("We give up.\n");                                              
          printf("Make sure you have specified the right host name,\n");        
          printf(                                                               
       " and that the server is running on it on the same port as us (%d).\n",  
                 port);                                                         
          exit(0);                                                              
        }                                                                       
      TimedOutThisCycle = TRUE;                                                 
      PlotTheGoodStuff();                                                       
    }                                                                           
    else                                                                        
    { nTriesToConnect = 0;                                                      
      do { retcode = TryANonBlockingRecv(&CurrAckNum); } /*(4)*/                
         while((retcode > 0) && (CurrAckNum < CurrDgramNum));                   
      if (retcode > 0)                                                          
        { HandleTheAck(&DontCare, &DontCare, &DontCare);                        
          NewCountsAvailable = 1;                                               
        }                                                                       
    }                                                                           
                                                                                
  CurrDgramNum = CurrDgramNum + 1;                                              
                                                                                
  if (monitor_the_monitor) printf("\n");                                        
                                                                                
  msg(3, "", "Leaving TransmitForXMonitor().");                                 
} /* TransmitForXMonitor() */                                                   
                                                                                
/*======================*                                                       
 | --TryABlockingRecv() |                                                       
 *======================*/                                                      
                                                                                
int TryABlockingRecv()                                                          
{ char buf20[21];                                                               
  int  lenaddr, retcode;                                                        
  lenaddr = sizeof(struct sockaddr);                                            
  msg(-3, "b", "TryABlockingRecv():");                                          
                                                                                
#if defined(MVS)                                                                
  if (montcpip)  /* Allow MVS operator STOP command. */                         
    { FD_ZERO((struct fd_set *)&fdvect);                                        
      FD_SET(s, (struct fd_set *)&fdvect);                                      
      msg(3, "", "About to selectex() on read socket or operator command.");    
      retcode = selectex(s+1, (struct fd_set *) &fdvect,                        
                            (struct fd_set *)0, (struct fd_set *)0,             
                            (struct timeval *) NULL,                            
                            (int *) (comlist->ecb));                            
      msg1(3, "Back from selectex(), comlist->cib=%d.",comlist->cib);           
      while (comlist->cib)                                                      
        { switch(comlist->cib->verb)                                            
            { case                                                              
                cibstop:                                                        
                  { msg(0, "",                                                  
                        "Received operator STOP command. Shutting down now.");  
                    NormalShutdown();                                           
                    exit(0);                                                    
                  }                                                             
                default: ;                                                      
            }                                                                   
          MVSqedit(&comlist->cib);                                              
        }                                                                       
    }                                                                           
#endif /* MVS */                                                                
                                                                                
#if defined(USEtcpip)                                                           
  retcode = recvfrom(s, (char *) &MsgBuf, buflen, 0,                            
                     (struct sockaddr *)&rsock, (size_rcv)&lenaddr);            
#else                                                                           
  retcode = 0;                                                                  
#endif                                                                          
  if (debug >= 2)                                                               
     if (retcode < 0)                                                           
       { printf("%s Blocking recvfrom() returns with rc=%d, ",                  
                msgp, retcode);                                                 
#if !defined(OS2)                                                               
         if (errno == EWOULDBLOCK)                                              
            printf("errno = EWOULDBLOCK.\n");                                   
            else printf("errno = %d.\n", errno);                                
#endif                                                                          
         oops("on recvfrom()");                                                 
       }                                                                        
       else                                                                     
       { ConvertToDottedDecimal(rsock.sin_addr.s_addr, buf20);                  
         printf(                                                                
           "%s Rcvd3 dgram number %d from %s/%d, len=%d, flags=%8X=\n",         
                 msgp, MsgBuf.dgram_num, buf20,                                 
                 rsock.sin_port, retcode, MsgBuf.flags);                        
         printf("%s     ", msgp);                                               
         SnapFlags(MsgBuf.flags);                                               
         if (debug >= 4)                                                        
            PrintDgram(&MsgBuf);                                                
       }                                                                        
  if (retcode < 0)                                                              
    { if (montcpip && (errno == EBADF))                                         
        { msg(0, "", "TCPIP has probably shutdown. We will too.");              
          NormalShutdown();                                                     
          exit(0);                                                              
        }                                                                       
        else                                                                    
        { oops("error on blocking recvfrom()"); }                               
    }                                                                           
    else { nbufrcvd = nbufrcvd + 1;                                             
           nbytrcvd = nbytrcvd + retcode;                                       
         }                                                                      
  if (receiver)                                                                 
    { AccumBlockingReceives = AccumBlockingReceives + 1;                        
      AccumBytesReceived  = AccumBytesReceived + retcode;                       
      AccumDgramsReceived = AccumDgramsReceived + 1;                            
    }                                                                           
                                                                                
  return(retcode);                                                              
                                                                                
}  /* TryABlockingRecv() */                                                     
                                                                                
/*=========================*                                                    
 | --TryANonBlockingRecv() |                                                    
 *=========================*/                                                   
                                                                                
int TryANonBlockingRecv(dgramnum)                                               
int *dgramnum;                                                                  
{ char buf20[21];                                                               
  int  lenaddr, retcode;                                                        
  lenaddr = sizeof(struct sockaddr);                                            
  msg(-3, "n", "TryANonBlockingRecv():");                                       
#if defined(USEtcpip)                                                           
  retcode = recvfrom(s, (char *)&MsgBuf, buflen, 0,                             
                     (struct sockaddr *)&rsock, (size_rcv)&lenaddr);            
#else                                                                           
  retcode = 0;                                                                  
#endif                                                                          
  *dgramnum = MsgBuf.dgram_num;                                                 
  if (debug >= 2)                                                               
     if (retcode < 0)                                                           
       { if (debug >= 3)                                                        
           { printf("%s Non-blocking recvfrom() returns with rc=%d, ",          
                    msgp, retcode);                                             
#if !defined(OS2)                                                               
             if (errno == EWOULDBLOCK)                                          
                printf("errno = EWOULDBLOCK.\n");                               
                else printf("errno = %d.\n", errno);                            
#endif                                                                          
           }                                                                    
       }                                                                        
       else                                                                     
       { ConvertToDottedDecimal(rsock.sin_addr.s_addr, buf20);                  
         printf(                                                                
           "%s Rcvd4 dgram number %d from %s/%d, len=%d, flags=%8X=\n",         
                msgp, MsgBuf.dgram_num, buf20,                                  
                rsock.sin_port, retcode, MsgBuf.flags);                         
         printf("%s     ", msgp);                                               
         SnapFlags(MsgBuf.flags);                                               
         if (debug >= 4)                                                        
            PrintDgram(&MsgBuf);                                                
       }                                                                        
  if (monitor_the_monitor && (retcode < 0)) printf(".");                        
  if (receiver)                                                                 
     if (retcode >= 0)                                                          
       { AccumNonBlockingReceives = AccumNonBlockingReceives + 1;               
         AccumBytesReceived  = AccumBytesReceived + retcode;                    
         AccumDgramsReceived = AccumDgramsReceived + 1;                         
       }                                                                        
  if (retcode >= 0)                                                             
    { nbufrcvd = nbufrcvd + 1;                                                  
      nbytrcvd = nbytrcvd + retcode;                                            
    }                                                                           
  return(retcode);                                                              
                                                                                
}  /* TryANonBlockingRecv() */                                                  
                                                                                
