//CBSAMPLJ JOB (509734,1024,503,G51,,N),'COMPILE',MSGLEVEL=(1,1),               
//          CLASS=A,TIME=1440,NOTIFY=userid                                     
//*                                                                             
//*********************************************************************         
//*                                                                   *         
//*   Licensed Materials - Property of IBM                            *         
//*   "Restricted Materials of IBM"                                   *         
//*   5694-A01                                                        *         
//*   (C) Copyright IBM Corp. 1999, 2003                              *         
//*   Status = CSV1R5                                                 *         
//*                                                                   *         
//*********************************************************************         
//*                                                                             
//*  This is starter JCL for compiling and linking the server piece             
//*  of the sample program, CBSAMPLE.  To use it, you should do the             
//*  following:                                                                 
//*                                                                             
//*    1. Customize the job card for your installation.                         
//*    2. Set the "Library Substitution Variables" below to values              
//*       that are appropriate for your installation.                           
//*                                                                             
//*********************************************************************         
//*                                                                             
//COMPLINK PROC COMPPGM='CBCDRVR',       < COMPILER PROGRAM                     
//*-------------------------------------------------------------------*         
//*               Compile Process Option Variables                    *         
//*-------------------------------------------------------------------*         
//  CREGSIZ='4M',                        < COMPILER REGION SIZE                 
//  CRUN=,                               < COMPILER RUNTIME OPTIONS             
//  CPARM1='NORENT',                     < COMPILER OPTIONS PT. 1               
//  CPARM2=,                             < COMPILER OPTIONS PT. 2               
//  CPARM3='LIS,SO,SHOW,EXP,MAR(1,80),NOSEQ,DEF(MVS,IBMCPP),OPT',               
//*                                      < COMPILER OPTIONS PT. 3               
//*-------------------------------------------------------------------*         
//*                Library Substitution Variables                     *         
//*-------------------------------------------------------------------*         
//*                                                                             
//*             Distribution Library Names/Prefixes                             
//*             -----------------------------------                             
//  CCOMPLIB='fully_qualified_C/C++_compiler_library_name',                     
//  OERTLPFX='hlq_for_Open_Edition_runtime_library(SCEERUN)',                   
//  OELIBPFX='hlq_for_Open_Edition_header/link_libs(SCEEH.*,SCEELKED)',         
//  TCPIPPFX='hlq_for_TCP/IP_distribution_libraries(SEZA*)',                    
//  YOURHLQ='hlq_for_downloaded_library.CBSAMPLE',                              
//  AMODSPFX='hlq_for_TCP/IP_AEZAMODS_library',                                 
//*                                                                             
//*                 User Private Library Names                                  
//*                 --------------------------                                  
//  USERLOAD='your_load_library',                                               
//*                                                                             
//*-------------------------------------------------------------------*         
//*                    Data Set Variables                             *         
//*-------------------------------------------------------------------*         
//  OBJATTR='DISP=(MOD,PASS),UNIT=VIO,SPACE=(CYL,(3,3,1))',                     
//  DCB80='(RECFM=FB,LRECL=80,BLKSIZE=3200)',      <DCB FOR LRECL 80            
//  DCB137='(RECFM=VB,LRECL=137,BLKSIZE=882)',     <DCB FOR LRECL 137           
//  DCB3200='(RECFM=FB,LRECL=3200,BLKSIZE=12800)'  <DCB FOR LRECL 3200          
//*                                                                             
//*********************************************************************         
//*  Compile step: (cbsamplc - Main program)                                    
//*********************************************************************         
//COMPC    EXEC PGM=&COMPPGM,REGION=&CREGSIZ,                                   
//    PARM=('&CRUN/&CPARM1 &CPARM2 &CPARM3')                                    
//STEPLIB  DD  DSNAME=&OERTLPFX..SCEERUN,DISP=SHR                               
//         DD  DSNAME=&CCOMPLIB,DISP=SHR                                        
//SYSIN    DD  DSNAME=&YOURHLQ..CBSAMPLE(CBSAMPLC),DISP=SHR                     
//SYSLIB   DD  DSNAME=&TCPIPPFX..SEZACMAC,DISP=SHR                              
//         DD  DSNAME=&OELIBPFX..SCEEH.H,DISP=SHR                               
//         DD  DSNAME=&OELIBPFX..SCEEH.SYS.H,DISP=SHR                           
//         DD  DSNAME=&TCPIPPFX..SEZANMAC,DISP=SHR                              
//         DD  DSNAME=&TCPIPPFX..SEZAINST,DISP=SHR                              
//         DD  DSNAME=&YOURHLQ..CBSAMPLE,DISP=SHR                               
//SYSLIN   DD  DSN=&&LOADSETC(CBSAMPLC),&OBJATTR,DCB=&DCB80                     
//SYSOUT   DD  SYSOUT=*                                                         
//SYSPRINT DD  SYSOUT=*                                                         
//SYSCPRT  DD  SYSOUT=*                                                         
//SYSUT1   DD  UNIT=VIO,SPACE=(32000,(30,30)),DCB=&DCB80                        
//SYSUT4   DD  UNIT=VIO,SPACE=(32000,(30,30)),DCB=&DCB80                        
//SYSUT5   DD  UNIT=VIO,SPACE=(32000,(30,30)),DCB=&DCB3200                      
//SYSUT6   DD  UNIT=VIO,SPACE=(32000,(30,30)),DCB=&DCB3200                      
//SYSUT7   DD  UNIT=VIO,SPACE=(32000,(30,30)),DCB=&DCB3200                      
//SYSUT8   DD  UNIT=VIO,SPACE=(32000,(30,30)),DCB=&DCB3200                      
//SYSUT9   DD  UNIT=VIO,SPACE=(32000,(30,30)),DCB=&DCB137                       
//SYSUT10  DD  SYSOUT=*                                                         
//*                                                                             
//*********************************************************************         
//*  Compile step: (cbsamplm - Monitor interface to TCP/IP)                     
//*********************************************************************         
//COMPM    EXEC PGM=&COMPPGM,REGION=&CREGSIZ,                                   
//    PARM=('&CRUN/&CPARM1 &CPARM2 &CPARM3')                                    
//STEPLIB  DD  DSNAME=&OERTLPFX..SCEERUN,DISP=SHR                               
//         DD  DSNAME=&CCOMPLIB,DISP=SHR                                        
//SYSIN    DD  DSNAME=&YOURHLQ..CBSAMPLE(CBSAMPLM),DISP=SHR                     
//SYSLIB   DD  DSNAME=&TCPIPPFX..SEZACMAC,DISP=SHR                              
//         DD  DSNAME=&OELIBPFX..SCEEH.H,DISP=SHR                               
//         DD  DSNAME=&OELIBPFX..SCEEH.SYS.H,DISP=SHR                           
//         DD  DSNAME=&TCPIPPFX..SEZANMAC,DISP=SHR                              
//         DD  DSNAME=&TCPIPPFX..SEZAINST,DISP=SHR                              
//         DD  DSNAME=&YOURHLQ..CBSAMPLE,DISP=SHR                               
//SYSLIN   DD  DSN=&&LOADSETM(CBSAMPLM),&OBJATTR,DCB=&DCB80                     
//SYSOUT   DD  SYSOUT=*                                                         
//SYSPRINT DD  SYSOUT=*                                                         
//SYSCPRT  DD  SYSOUT=*                                                         
//SYSUT1   DD  UNIT=VIO,SPACE=(32000,(30,30)),DCB=&DCB80                        
//SYSUT4   DD  UNIT=VIO,SPACE=(32000,(30,30)),DCB=&DCB80                        
//SYSUT5   DD  UNIT=VIO,SPACE=(32000,(30,30)),DCB=&DCB3200                      
//SYSUT6   DD  UNIT=VIO,SPACE=(32000,(30,30)),DCB=&DCB3200                      
//SYSUT7   DD  UNIT=VIO,SPACE=(32000,(30,30)),DCB=&DCB3200                      
//SYSUT8   DD  UNIT=VIO,SPACE=(32000,(30,30)),DCB=&DCB3200                      
//SYSUT9   DD  UNIT=VIO,SPACE=(32000,(30,30)),DCB=&DCB137                       
//SYSUT10  DD  SYSOUT=*                                                         
//*                                                                             
//*********************************************************************         
//*  Linkedit step:                                                             
//*********************************************************************         
//LINK      EXEC PGM=IEWL,                                                      
//     PARM=',LIST,MAP,RMODE(ANY),SIZE=(320K,64K)'                              
//SYSOUT   DD SYSOUT=*                                                          
//SYSPRINT DD SYSOUT=*                                                          
//SYSUT1   DD UNIT=SYSDA,SPACE=(CYL,(1,1))                                      
//SYSLIB   DD DSN=&TCPIPPFX..SEZACMTX,DISP=SHR                                  
//         DD DSN=&OELIBPFX..SCEELKED,DISP=SHR                                  
//AEZAMODS DD DSN=&AMODSPFX..AEZAMODS,DISP=SHR                                  
//USERLIBC DD DSN=&&LOADSETC,DISP=(OLD,DELETE)                                  
//USERLIBM DD DSN=&&LOADSETM,DISP=(OLD,DELETE)                                  
//SYSLMOD  DD DSN=&USERLOAD,DISP=SHR                                            
//    PEND                                                                      
//    EXEC PROC=COMPLINK                                                        
//LINK.SYSLIN   DD *                                                            
 INCLUDE AEZAMODS(EZBOECPR)          * COPYRIGHT STATEMENT                      
 INCLUDE USERLIBC(CBSAMPLC)                                                     
 INCLUDE USERLIBM(CBSAMPLM)                                                     
 ORDER EZBOECPR                                                                 
 ENTRY CEESTART                      * STANDARD C MODULE ENTRY POINT            
 NAME  CBSAMPLE(R)                                                              
//*                                                                             
